<?php
/****************************/
/*inicio funciones generales*/
/****************************/

/*Funcion que compara si 2 parametros son iguales, si son diferentes
devolvera false y sin son iguales devolvera true*/
function comp($parami,$paramf){
	if ($parami != $paramf){
		return false;
	}else{
		return true;
	}
}

/*Evalua si una cadena cumple los caracteres que se le pasen como argumento,
esta funcion recibe 2 parametros, el primero es la cadena a evaluar y el segundo
la cadena de caracteres permitidos (esta cadena sera en forma de expresion regular),
returna verdadero en caso de coincidir, de lo contrario devuelve false*/
function scar($cad,$car){
	$result=preg_match($car,$cad);
	if($result=="0"){
		return true;
	}else{
		return false;
	}
}

/*Funcion que construye la forma correcta de colocar tablas y campos
de una cadena para una consulta para mysql usando variables, recordar que
para ganar rendimiento siempre se debe poner: "tabla.columna", para que
la base de datos tenga un mejor rendimiento, valores que acepta son
tabla y columna*/
function csc($tbl,$clmn){
	$cad="" . $tbl . '.' . $clmn . "";
	return $cad;
}

/*Funcion que determina si existe un determinado registro en una base de
datos, si no existe, devolvera falso, si existe devolvera el valor, recibe
4 parametros, estos parametros que acepta son: columna, tabla, indice
o prymary key/valor, y por ultimo la cadena de conexion a la db*/
function exist($column,$tabl,$ind,$vlor,$cnx){
	/*incluimos conexion a la db*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*preparamos cadena para la consulta*/
	$caden="select " . csc($tabl,$column) . " from " . $tabl . " where  " . csc($tabl,$ind) . " = " . $vlor . "";
	/*ejecutamos cadena con la consulta*/
	$sqlexe=$bd->ListarDatos($caden);
	/*recorremos resultado de consulta*/
	$consul=mysql_fetch_array($sqlexe);
	/*evaluamos si consulta devolvio valor de ser asi devolvemos la consulta*/
	if ($consul != ''){
		return $consul;
	/*de lo contrario devolvemos falso*/
	}else{
		return false;
	}
}

/*convierte una fecha en formato 0000-00-00 00:00:00 a unix ejemplo
1276120800*/
function funix($fnor){
	$funx=strtotime(date($fnor));
    return $funx;
}

/*funcion que se usa para determinar si un registro temporal ha expirado*/
function fexp($idsis,$col,$tab0,$in,$val,$cnx){
	/*obtengo fecha cuando se realizo registro temporal en segundos*/
	$fecregec=exist($col,$tab0,$in,$val,$cnx);
	$fecreg=$fecregec["tmp_fcnf"];
	/*obtengo tiempo limite fijada en la db de expiracion del registro*/
	$t_expc=exist("cnf_rtmp_exp","w_conf","cnf_nomsis","'".$idsis."'",$cnx);
	$t_exp=$t_expc["cnf_rtmp_exp"];
	/*Sumo ambos valores para obtener la fecha en que debe expirar el registro*/
	$t_totexp=($t_exp + $fecreg);
	/*obtengo tiempo actual en formato unix*/
	$t_act=time();
	//return $t_totexp;
	/*realizamos la evaluacion de fechas*/
	if ($t_act > $t_totexp){
	/*si la fecha actual es mayor q la fecha de vencimiento
	retorna "falso", significa que expiro el registro*/
	return false;
	/*de lo contrario*/
	}else{
	/*devuelve verdadero*/
	return true;
	}
}

/*funcion para obtener la clave de un combo, esta funcion obtiene la clave
de un valor especifico de un array, es simple, recibe 2 parametros, uno es
el array en el cual se buscara la clave y el otro parametro es el valor
asociado a la clave, retorna la clave del valor pasado como parametro*/
function clavecb($arr,$val){
	/*Iniciamos el recorrido del array*/
	foreach ($arr as $clave=>$valor) {
		/*Evaluamos si el valor recorrido coincide con el valor pasado como parametro*/
		if($valor===$val) {
			/*Si es asi, obtenemos la clave del valor y lo asignamos a variable*/
			$cla=$clave;
		}
	}
	/*retornamos la clave*/
	return $cla;
}
/*************************/
/*fin funciones generales*/
/*************************/

/********************************************/
/*inicio funciones exclusivamente para SWIGC*/
/********************************************/

/*Inicio funciones para panel administrativo*/

/*funcion que consulta el nombre del sistema, recibe 3 parametros
el primero es la tabla donde se guarda la configuracion del sistema
el segundo la columna que tiene el nombre del sistema y la ruta hacia
la conexion con la db*/
function nsis($tbcnf,$clnsis,$cnx) {
	/*incluimos conexion a la db*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*Consultamos el nombre del sistema, primero preparamos cadena para consulta*/
	$cad_cnis="select " . csc($tbcnf,$clnsis) . " from " . $tbcnf . " limit 1";
	/*ejecutamos consulta con la db*/
	$con_cnis=$bd->ListarDatos($cad_cnis);
	/*recorremos resultado de consulta*/
	$nsis=mysql_fetch_row($con_cnis);
	/*retornamos variable con nombre del sistema*/
	return $nsis;
}
/*Funcion que consulta el nombre de los campos de una tabla en mysql
acepta 3 parametros, el nombre de la db, el nombre de la tabla y
finalmente la ruta hacia la coneccion con la db, devuelve un array
con el nombre de las columnas*/
function cmpdb($ndb,$tab1,$cnx) {
	/*incluimos conexion a la db*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*Procesos para consultar el nombre de las columnas*/
	$cad_sldb="use information_schema";
	$con_sldb=$bd->ListarDatos($cad_sldb);
	
	$cad_cncl="SELECT COLUMN_NAME FROM COLUMNS WHERE TABLE_SCHEMA = '" . $ndb . "' AND TABLE_NAME = '" . $tab1 . "'";
	$con_cncl=$bd->ListarDatos($cad_cncl);
	/*Recorremos la consulta y asignamos valores a array*/
		/*Iniciamos contador*/
		$w='0';
		
		/*Iniciamos el bucle para recorrer los resultados, nota: necesariamente tiene que ser de esta forma
		ya intente con foreach y otros bucles*/
		while($reg=mysql_fetch_row($con_cncl) ){
			/*Recordar que cada registro esta en un array, por eso hacemos referencia a la posicion 0 del
			array resultante*/			
			$clm[$w]=$reg["0"];
			/*Aumentamos contador en 1*/
			$w++;
		}
	/*Asignamos al ultimo valor el nombre de la tabla*/
	//$clm[$w]=$tab1;
	/*Volvemos a seleccionar la tabla de trabajo*/
	$bd->ListarDatos("use prosol");
	/*retornamos array con todos los campos de la tabla*/
	return $clm;
}

/*Funcion que construye un select dividido en 4 partes, la primera parte es el select propiamente,
la segunda parte es el where (solo si existe de lo contrario devuelve esta parte en vacio),
la tercera es el and (solo si existe de lo contrario devuelve esta parte en vacio), y la cuarta
parte la clausula limit (solo si existe de lo contrario devuelve esta parte en vacio).

Acepta clausulas where y and ilimitadas

Funciona en 2 modalidades: consulta simple y consulta con filtros;

Recibe 7 parametros, el primero, es un array con los valores que seran los nombres de los botones del
formulario por el cual se genera la consulta, es decir la funcion se creo con el objetivo de solucionar
una consulta que procediera de un formulario, por lo tanto cuando se realiza el submit, el formulario envia
los nombres de los campos, estos campos los ponemos en un array y se lo enviamos a la funcion, estos campos
se usaran en la clausula where "where columna=nombre de campo["valor"]" si se usa modalidad simple, dejar
esta variable en cero, el segundo es un array que tiene el nombre de las columnas que se usaran para comparar
con el valor de que tengan las variables con los nombres de los campos del formulario, es decir del array
anterior si se usa consulta simple, dejar esta variable en cero, el tercero es un array que tiene los valores
de los campos recuperados del formulario con request, si se usa consulta simple, dejar esta variable en cero,
el cuarto  un array que definira si la consulta tendra un limite, este array tiene 3 posiciones, la primera
es una cadena de texto con la palabra limite (si no se quisiera limite, esta cadena se quedaria sin texto
osea vacio ""), la segunda indica desde q registro comienza la consulta y la tercera es hasta que registro
sera la consulta, el quinto parametro, es un array que contendra todas las tablas de las cuales se
seleccionaran sus columnas en la consulta, el sexto parametro, es un array que contiene todas las columnas
de todas las tablas que vamos a seleccionar en la consulta y el setimo, establece si la consulta usara filtro
(>) para operador numerico, es decir que si el valor comparado es un numero no se usara like, si no que se
usara el signo mayor > para evaluar por el momento solo soporta signo mayor, retorna un array con la cadena
select dividida en 4 partes

Ejemplo de uso:

Primero aclarar que la funcion usa arrays multidimencionales, esto es porque la funcion esta preparada para
aceptar consulta a varias tablas y sus columnas asociadas, asi como los valores a comparar para las columnas
asociadas, por lo tanto la unica forma de que esto sea posible, es usando arrays multimencionales, solo
usaran arrays multidimencionales los arrays correspondientes a "columnas a comparar", "valores para comparar",
"columnas a seleccionar", el resto de los arrays no es necesario ya que usando arrays simples se puede
especificar varios valores:

$filtro["0"]["0"]="txtdni"
$filtro["0"]["1"]="txtnombre"

$columna_comparar["0"]["0"]="cli_dni"
$columna_comparar["0"]["1"]="cli_nombre"

$valor_comparar["0"]["0"]="42585852"
$valor_comparar["0"]["1"]="ARGELIO SERNA"

$limit["0"]=Limit
$limit["1"]=0
$limit["2"]=20

$tablas["0"]="w_usuarios"

$columnas_a_seleccionar["0"]["0"]="cli_telefono"
$columnas_a_seleccionar["0"]["1"]="cli_celular"
$columnas_a_seleccionar["0"]["2"]="cli_direccion"

$check_filtro="1"

consl($filtro,$columna_comparar,$valor_comparar,$limit,$tablas,$columnas_a_seleccionar,$check_filtro)

resultado:
   [0] => select w_usuarios.cli_telefono, w_usuarios.cli_celular, w_usuarios.cli_direccion  from w_usuarios
   [1] => where w_usuarios.cli_dni >= '42585852'
   [2] => and w_usuarios.cli_nombre like 'ARGELIO SERNA%'
   [3] => Limit 0, 20

*/
function consl2($flts,$clm_comp,$val_comp,$limit,$tbls,$clms,$fltfc) {
	/*Definimos variables a utilizar*/
	$cad_whr="";
	$cad_and="";
	$cad_lmt="";
	$cad_cmps="";
	$cad_clms="";
	$cad_tbls="";
	$arr_cad=array();
	$cnt="";
	$dlm="";
	/*Definimos contador que definira si lleva la clausula where y and*/
	$cnt="0";
	/*Iniciamos la variable que contendra el separador*/
	$sep=",";
	/*Bucle para los filtros, primero evaluamos si no se trata de una consulta simple, para ello evaluamos el
	primer array que tiene los filtros y cada filtro tiene el nombre de las variable pero no su valor, si se
	trata de consulta simple este array no existe solo es valor cero*/
	if(isset($flts) && $flts != "0"){
		/*Si no es consulta simple, recorremos todas los filtros existentes, esto se logra
		con el array que contiene el nombre de los campos que se compararan con los filtros,
		debido a que la cantidad de campos son eqivalentes al total de los filtros aplicados,
		le restamos uno porque se cuenta desde el cero.

		Primero recorremos las tablas a las que se realizara la consulta*/
		for($a=0;$a<=(count($tbls)-1);$a++){
			/*Luego recorremos los filtros*/
			for($i=0;$i<=(count($flts[$a])-1);$i++) {
				/*si el valor de la caja de texto esta seteado y si es diferente de vacio*/
				if(isset($val_comp[$flts[$a][$i]]) && $val_comp[$flts[$a][$i]] != '' ) {
					/*Evaluamos el contador que definira las claulas where y and*/
					switch(true){
						/*Si es cero construimos cadena solo con where*/
						case $cnt == "0":
							/*Evaluamos si se aplico el filtro para la fecha, recordar que la fecha viene en formato
							unix osea que es valor numerico, de ser asi contruyo cadena con operador numerico*/
							if(is_numeric($val_comp[$flts[$a][$i]]) && $fltfc=='1') {
								/*Variable que tendra la porcion de la clausula where*/
								$cad_whr=" where " . $tbls[$a] . "." . $clm_comp[$a][$i] . " >= '" . $val_comp[$flts[$a][$i]] . "'";
							/*De lo contrario lo construyo con like*/					
							}else{
								/*Variable que tendra la porcion de la clausula where*/
								$cad_whr=" where " . $tbls[$a] . "." . $clm_comp[$a][$i] . " like '" . $val_comp[$flts[$a][$i]] . "%'";
							}
							/*Aumentamos el contador de las clausulas en 1*/
							$cnt++;
							break;
							/*Si el contador aumento de cero, entonces vamos aumentando las clausulas and*/
						case $cnt >= "1":
							/*Evaluamos si se aplico el filtro para la fecha, recordar que la fecha viene en formato
							unix osea que es valor numerico, de ser asi contruyo cadena con operador numerico*/
							if(is_numeric($val_comp[$flts[$a][$i]]) && $fltfc=='1') {
								/*Variable que tendra la porcion de la clausula and*/
								$cad_and=$cad_and . " and " . $tbls[$a] . "." . $fltsc[$a][$i] . " >= '" . $val_comp[$flts[$a][$i]] . "'";
							}else{
								/*Variable que tendra la porcion de la clausula and*/
								$cad_and=$cad_and . " and " . $tbls[$a] . "." . $fltsc[$a][$i] . " like '" . $val_comp[$flts[$a][$i]] . "%'";
							}
							/*Aumentamos el contador de las clausulas en 1*/
							$cnt++;
							break;
					}			
				}
			}
		}
	}
	/*Bucle para los filtros, evaluamos si tenemos establecido el soporte para la clausula Limit si
	esta establecido construimos la cadena con limit y los valores correspondientes*/
	if(isset($limit['0']) && $limit['0'] != "") {
		/*Variable que tendra la porcion de la clausula limit*/
		$cad_lmt=" Limit " . $limit['1'] . ", " . $limit['2'] . "";
	}
	/*Bucle para los campos, primero recorremos las tablas enviadas a la funcion*/
	for($z=0;$z<=(count($tbls)-1);$z++){
		/*Luego recorremos recorremos los campos*/
		for($c=0; $c<=(count ($clms[$z]) -1); $c++){
			/*vamos construyendo la cadena de valores, para ello primero evaluamos
			si el contador esta en el ultimo registro, de ser asi, el delimitador
			debe contener un valor vacio para que el final de la cadena no tenga el delimitador*/
			if ($z==(count($tbls)-1) && $c==count($clms[(count($tbls)-1)])-1){
				$sep="";
			}
			/*Evaluamos si nos encontramos en el primer registro ya que este no sera mostrado*/
			if($c != "0") {
				/*Variable que tendra la porcion de los campos que iremos construyendo*/
				$cad_clms = $cad_clms . $tbls[$z] . "." . $clms[$z][$c] . $sep . " ";
			}
		}
	}
	/*Devolvemos el valor por defecto al separador para usarlo mas adelante*/
	$sep=",";

	/*Bucle para las tablas*/
	for($z=0;$z<=(count($tbls)-1);$z++){
		/*vamos construyendo la cadena de valores, para ello primero evaluamos
		si el contador esta en el ultimo registro, de ser asi, el delimitador
		debe contener un valor vacio para que el final de la cadena no tenga el delimitador*/
		if ($z==count($tbls) -1){
			$sep="";
		}
		$cad_tbls=$cad_tbls . $tbls[$z] . $sep . " ";
	}

	/*Asignamos los valores al array resultante con la cadena de la consulta en partes*/
	$arr_cad['0']="select " . $cad_clms . " from " . $cad_tbls;
	$arr_cad['1']=$cad_whr;
	$arr_cad['2']=$cad_and;
	$arr_cad['3']=$cad_lmt;
	/*Retornamos el array con la cadena de consulta*/
	return $arr_cad;
//	return count ($clms['0']);
}

/*Funcion que construye un select dividido en 4 partes, la primera parte es el select propiamente,
la segunda parte es el where (solo si existe de lo contrario devuelve esta parte en vacio),
la tercera es el and (solo si existe de lo contrario devuelve esta parte en vacio), y la cuarta
parte la clausula limit (solo si existe de lo contrario devuelve esta parte en vacio).

Acepta clausulas where y and ilimitadas

Funciona en 2 modalidades: consulta simple y consulta con filtros;

Recibe 7 parametros, el primero es un array que tiene el nombre de las columnas que se usaran para comparar
con los valores que enviaremos, si se usa consulta simple, dejar esta variable en cero, el segundo es un array
que tiene los valores con los que deseamos comparar las columnas del array anterior, si se usa consulta simple,
dejar esta variable en cero, el cuarto  un array que definira si la consulta tendra un limite, este array tiene
2 posiciones, la primera indica desde q registro comienza la consulta y la segunda es hasta que registro
sera la consulta (si no se quisiera limite, dejar la segunda posicion osea vacio ""), el cuarto parametro,
es un array que contendra todas las tablas de las cuales se seleccionaran sus columnas en la consulta, el quinto
parametro, es un array que contiene todas las columnas de todas las tablas que vamos a seleccionar en la consulta,
el sexto establece si la consulta usara filtro numerico, es decir, generalmente se usa like para todas las
comparaciones, pero puede darse el caso de que el valor a comparar sea un numero, y no queremos un like si no
un valor menor o mayor que ese, esto no se podria con like tiene que ser < o > para lograrlo, por eso is esta
activa esta opccion y si el valor es numerico no se usara like, si no que se usara el signo mayor > para evaluar,
para activar esta opccion simplemente poner cualquier cosa en este valor, si no se deseara, dejarlo en blanco, por
el momento solo soporta signo mayor, y el septimo parametro, define si mostraremos el primer valor de la primera
columna de la tabla, (por ejemplo en caso de que la primera columna tenga un codigo y no deseamos que se muestre),
para activarla basta especificar cualquier caracter en esta variable, si no se desea utilizar, dejar en blanco, 
devuelve una cadena con un select dividido en 4 partes

Ejemplo de uso:

Primero aclarar que la funcion usa arrays multidimencionales, esto es porque la funcion esta preparada para
aceptar consulta a varias tablas y sus columnas asociadas, asi como los valores a comparar para las columnas
asociadas, por lo tanto la unica forma de que esto sea posible, es usando arrays multimencionales, solo
usaran arrays multidimencionales los arrays correspondientes a "columnas a comparar", "valores para comparar",
"columnas a seleccionar", el resto de los arrays no es necesario ya que usando arrays simples se puede
especificar varios valores:

$columna_comparar["0"]["0"]="cli_dni"
$columna_comparar["0"]["1"]="cli_nombre"

$valor_comparar["0"]["0"]="42585852"
$valor_comparar["0"]["1"]="ARGELIO SERNA"

$limit["1"]=0
$limit["2"]=20

$tablas["0"]="w_usuarios"

$columnas_a_seleccionar["0"]["0"]="cli_telefono"
$columnas_a_seleccionar["0"]["1"]="cli_celular"
$columnas_a_seleccionar["0"]["2"]="cli_direccion"

$usar_comparador_numerico="1"
$nomostrar_primer_reg="1"

consl($columna_comparar,$valor_comparar,$limit,$tablas,$columnas_a_seleccionar,$usar_comparador_numerico,$nomostrar_primer_reg)

resultado:
   [0] => select w_usuarios.cli_celular, w_usuarios.cli_direccion  from w_usuarios
   [1] => where w_usuarios.cli_dni >= '42585852'
   [2] => and w_usuarios.cli_nombre like 'ARGELIO SERNA%'
   [3] => Limit 0, 20

*/
function consl($clm_comp,$val_comp,$limit,$tbls,$clms,$cmp_num,$preg) {
	/*Definimos variables a utilizar*/
	$cad_whr="";
	$cad_and="";
	$cad_lmt="";
	$cad_cmps="";
	$cad_clms="";
	$cad_tbls="";
	$arr_cad=array();
	$cnt="";
	$dlm="";
	/*Definimos contador que definira si lleva la clausula where y and*/
	$cnt="0";
	/*Iniciamos la variable que contendra el separador*/
	$sep=",";
	/*Bucle para los filtros, primero evaluamos si no se trata de una consulta simple, para ello evaluamos el
	primer array que tiene los filtros y cada filtro tiene el nombre de las variable pero no su valor, si se
	trata de consulta simple este array no existe solo es valor cero*/
	if(isset($clm_comp) && $clm_comp != ""){
		/*Si no es consulta simple, recorremos todas los filtros existentes, esto se logra
		con el array que contiene el nombre de los campos que se compararan con los filtros,
		debido a que la cantidad de campos son eqivalentes al total de los filtros aplicados,
		le restamos uno porque se cuenta desde el cero.

		Primero recorremos las tablas a las que se realizara la consulta*/
		for($a=0;$a<=(count($tbls)-1);$a++){
			/*Luego recorremos los filtros*/
			for($i=0;$i<=(count($clm_comp[$a])-1);$i++) {
				/*Evaluamos el contador que definira las claulas where y and*/
				switch(true){
					/*Si es cero construimos cadena solo con where*/
					case ($cnt=="0" && isset($val_comp[$i])):
						/*Evaluamos si se aplico el filtro para la fecha, recordar que la fecha viene en formato
						unix osea que es valor numerico, de ser asi contruyo cadena con operador numerico*/
						if(is_numeric($val_comp[$i]) && $cmp_num != "") {
							/*Variable que tendra la porcion de la clausula where*/
							$cad_whr=" where " . $tbls[$a] . "." . $clm_comp[$a][$i] . " >= '" . $val_comp[$a][$i] . "'";
						/*De lo contrario lo construyo con like*/					
						}else{
							/*Variable que tendra la porcion de la clausula where*/
							$cad_whr=" where " . $tbls[$a] . "." . $clm_comp[$a][$i] . " like '" . $val_comp[$a][$i] . "%'";
						}
						/*Aumentamos el contador de las clausulas en 1*/
						$cnt++;
						break;
						/*Si el contador aumento de cero, entonces vamos aumentando las clausulas and*/
					case $cnt >= "1":
						/*Evaluamos si se aplico el filtro para la fecha, recordar que la fecha viene en formato
						unix osea que es valor numerico, de ser asi contruyo cadena con operador numerico*/
						if(is_numeric($val_comp[$a][$i]) && $cmp_num != "") {
							/*Variable que tendra la porcion de la clausula and*/
							$cad_and=$cad_and . " and " . $tbls[$a] . "." . $clm_comp[$a][$i] . " >= '" . $val_comp[$a][$i] . "'";
						}else{
							/*Variable que tendra la porcion de la clausula and*/
							$cad_and=$cad_and . " and " . $tbls[$a] . "." . $clm_comp[$a][$i] . " like '" . $val_comp[$a][$i] . "%'";
						}
						/*Aumentamos el contador de las clausulas en 1*/
						$cnt++;
						break;
				}	
			}
		}
	}
	/*Bucle para los filtros, evaluamos si tenemos establecido el soporte para la clausula Limit si
	esta establecido construimos la cadena con limit y los valores correspondientes*/
	if(isset($limit['1']) && $limit['1'] != "") {
		/*Variable que tendra la porcion de la clausula limit*/
		$cad_lmt=" Limit " . $limit['0'] . ", " . $limit['1'] . "";
	}
	/*Bucle para los campos, primero recorremos las tablas enviadas a la funcion*/
	for($z=0;$z<=(count($tbls)-1);$z++){
		/*Luego recorremos recorremos los campos*/
		for($c=0; $c<=(count ($clms[$z]) -1); $c++){
			/*vamos construyendo la cadena de valores, para ello primero evaluamos
			si el contador esta en el ultimo registro, de ser asi, el delimitador
			debe contener un valor vacio para que el final de la cadena no tenga el delimitador*/
			if ($z==(count($tbls)-1) && $c==count($clms[(count($tbls)-1)])-1){
				$sep="";
			}
			/*Evaluamos si nos encontramos en el primer registro y si hemos activado la opccion
			que evita mostrar el primer registro*/
			if($c != '0' || ($c == "0" && $preg == "")) {
				/*Variable que tendra la porcion de los campos que iremos construyendo*/
				$cad_clms = $cad_clms . $tbls[$z] . "." . $clms[$z][$c] . $sep . " ";
			}
		}
	}
	/*Devolvemos el valor por defecto al separador para usarlo mas adelante*/
	$sep=",";

	/*Bucle para las tablas*/
	for($z=0;$z<=(count($tbls)-1);$z++){
		/*vamos construyendo la cadena de valores, para ello primero evaluamos
		si el contador esta en el ultimo registro, de ser asi, el delimitador
		debe contener un valor vacio para que el final de la cadena no tenga el delimitador*/
		if ($z==count($tbls) -1){
			$sep="";
		}
		$cad_tbls=$cad_tbls . $tbls[$z] . $sep . " ";
	}

	/*Asignamos los valores al array resultante con la cadena de la consulta en partes*/
	$arr_cad="select " . $cad_clms . " from " . $cad_tbls . $cad_whr . $cad_and . $cad_lmt;
	/*Retornamos el array con la cadena de consulta*/
	return $arr_cad;
}

/*inicio funciones preguntas y alternativas*/

/*Funcion insertar en base de datos, esta funcion fue creada principalmente para insertar
y registrar todos los pasos que valla realizando el cliente en cada etapa de la validacion,
recibe 5 parametros, el primero es una variable con el nombre de la tabla, el segundo es
un array con todos los nombres de las columnas a las que se les insertara el valor, el
tercero es un array con todos los valores a insertar en los campos, el cuarto es el tipo de
operacion a realizar por el momento soporta solo INSERT y UPDATE, para especificar que es el
primero se envia el valor "i", para el segundo se envia el valor "u", el quinto valor es
para la sentencia where, ojo que solo acepta un valor el cual sera un array q contenga la
columna y el valor que finalmente evaluaremos para condicionar el insert o update a una fila
especifica segun nos convenga*/

function pvld_ins($tab,$clms,$vlrs,$tp,$cnd,$cnx){
	/*conexion con base de datos*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*inicializamos la variable que tendra la cadena de campos a los que se les insertara
	valores en la db*/
	$clm='';
	/*Iniciamos la variable que contendra el delimitador*/
	$dlm=',';
	/*Declaramos contador*/
	$m=0;
	/*iniciamos el bucle que recorrera las columnas y los valores a insertar en la tabla que
	registra todos los pasos del cliente, por cada valor del array ira construyendo la cadena
	para realizar el insert o el update segun sea el caso, este bucle lo logramos sabiendo
	cuantos elementos tiene el array y para ello los contamos con la funcion "count", la cual
	cuenta la cantidad de elementos que tiene un array*/
	
	/*Bucle para los campos*/
	foreach($clms as $obj){
		/*vamos construyendo la cadena de valores, para ello primero evaluamos
		si el contador esta en el ultimo registro, de ser asi, el delimitador
		debe contener un valor vacio para que el final de la cadena no tenga el delimitador*/
		if ($m==count($clms)-1){
			$dlm='';
		}
		/*construimos la cadena y la asignamos a una variable*/
		$clm = $clm . $tab . "." . $clms[$m] . "='" . $vlrs[$m] . "'" . $dlm;
		/*Incrementamos en uno el contador*/
		$m++;
	}
	/*iniciamos el selector que diferenciara si lo que deseamos hacer es un insert o un
	update para ello evaluamos la variable $tp la cual tendra el tipo de operacion deseada*/
	switch($tp){
		/*En caso sea insert*/
		case "i":
			/*Construmos la cadena para un insert*/
			$cadinstr = "insert into " . $tab . " SET " . $clm;
		break;
		/*En caso sea un update*/		
		case "u":
			/*Construimos la cadena para un update*/
			$cadinstr = "update " . $tab . " SET " . $clm . " WHERE " . $tab . "." . $cnd['0'] . "='" . $cnd['1'] . "'";
		break;
	}
	/*Insertamos la cadena en la base de datos*/
	$bd->ListarDatos($cadinstr);
	/*retornamos la cadena que fue ejecutada en caso se quiera evaluar esta funcion
	con un if, este valor que retorna le diria al if que es verdadero*/
	return $cadinstr;
	
}


/*Funcion que devuelve la cadena de la pregunta, recibe cinco parametros, el primero es el
dni, el segundo es el array que tiene el orden de las preguntas "ord", el tercer parametro
es un numero entre 0 y 4 este numero es el que especifica que numero de las 5 preguntas estamos,
el cuarto parametro es un array que contiene el nombre de la tabla donde se realizaran las
consultas y el nombre de los campos que contiene esa tabla, y el quinto la cadena de conexion a
la db. D/evuelve un array que contiene la pregunta fraccionada en 3 partes*/

function preg_val($fdni,$fordt,$nval,$fcdb1,$cnx){
	/*Establecemos la cadena de la base de datos*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*Cadena para consultar y construir la pregunta obtenida de la db*/
	$cpreg = "select " . csc($fcdb1["tab"],$fcdb1["c0"]) . ", " . csc($fcdb1["tab"],$fcdb1["c1"]) . ", " . csc($fcdb1["tab"],$fcdb1["c2"]) . ", " . csc($fcdb1["tab"],$fcdb1["c3"]) . " from " . $fcdb1["tab"] . " where " . csc($fcdb1["tab"],$fcdb1["c4"]) . " = '" . $fordt[$nval] . "'";
	$arrayreg = mysql_fetch_array($bd->ListarDatos($cpreg));	

	/*Realizamos la consulta para obtener el año de la deuda, este valor lo sacamos de la parte
	de la cadena $arrayreg['preg_p2'], este valor contiene el nombre del procedimiento almacenado
	el cual devuelve el año de la deuda, este valor se obtiene de la consulta anterior
	pero primero hay que evaluar que exista el nombre del procedure.*/
	if(isset($arrayreg[$fcdb1["c2"]]) && $arrayreg[$fcdb1["c2"]] != '') {
		$cad_pro = "call " . $arrayreg[$fcdb1["c2"]] . "(" . $fdni . ",@result)";
		$bd->ListarDatos($cad_pro)or die(mysql_error());
	
		/*Consultamos la respuesta arrojada por el procedimiento almacenado*/
		$cad_res = "select @result as result";
		$arr_res = mysql_fetch_array($bd->ListarDatos($cad_res));
		$act=$arr_res["result"];
	}else{
		$act='';
	}
	
	/*Inicializamos el array*/
	$arrcadpreg = array();
	
	$arrcadpreg['p0'] = utf8_encode($arrayreg[$fcdb1["c0"]]);	
	$arrcadpreg['p1'] = utf8_encode($arrayreg[$fcdb1["c1"]]);
	$arrcadpreg['p2'] = utf8_encode($act);
	$arrcadpreg['p3'] = utf8_encode($arrayreg[$fcdb1["c3"]]);
	
	return $arrcadpreg;
}

 /*Funcion que devuelve las alternativas, recibe cinco parametros, el primero es el dni, el
segundo es el array que tiene el orden de las preguntas "ord", el tercer parametro es un numero
entre 0 y 4 este numero es el que especifica que numero de las 5 preguntas estamos, el cuarto
parametro es un array que contiene el nombre de la tabla donde se realizaran las consultas y el
nombre de los campos que contiene esa tabla y el quinto la cadena de conexion a la db.
Devuelve un array que contiene las alternativas y otro array que contiene un numero que es el
numero de alternativa a la que pertenece el texto de la alternativa.*/

function alt_val($fdni,$fordt,$nval,$fcdb2,$cnx){
	/*necesario para la conexion a la base de datos*/
	include ($cnx);
	/*Creamos la clase a partir del constructor*/
	$bd = new datos();
	/*inicializamos las variables a utilizar*/
	$cevalprocV='';
	$reg='';
	/*Inicializo el array que sera utilizado en el recorrido al resultado del orden de las preguntas*/
	$arrayreg2=array();
	/*Inicializo el array que contendra las alternativas*/
	$arralts=array();
	/*Inicializo el array que contendra el codigo de la alternativa correcta*/
	$calter=array();
	/*Inicialzo primera la variable que tendra la cadena a ejecutar con la db en cada bucle, esta cadena solo se usa
	en caso lo que se valla a ejecutar sea un procedure*/
	$cejc0='';
	/*Inicialzo segunda la variable que tendra la cadena a ejecutar con la db en cada bucle*/
	$cejc1='';
	/*Inicializo array que tendra numeros al azahar para las 3 primeras alternativas*/
	$azalt=array();

	/*obtengo el nombre del procedure que verificara si existe respuesta correcta segun la pregunta
	(recordar que este procedure es siempre el de la serie 4 por ejemplo: sp_dirC4, etc)*/
	$cprocV = "select ".csc($fcdb2["tb"],$fcdb2["c5"])." from ".$fcdb2["tb"]." where ".csc($fcdb2["tb"],$fcdb2["c3"])." = '".$fordt[$nval]."' and ".csc($fcdb2["tb"],$fcdb2["c2"]). " = '4'";
	$arrayreg1 = mysql_fetch_array($bd->ListarDatos($cprocV));

	/*Ejecuto el procedure de la serie 4 con la base de datos*/
	$cevalprocV = "call ".$arrayreg1[$fcdb2["c5"]]."('". $fdni."',@r)";
	$bd->ListarDatos($cevalprocV)or die(mysql_error());

	/*obtengo el valor arrojado por el procedure*/
	$arrreval = mysql_fetch_array($bd->ListarDatos("select @r"));
	$creval = $arrreval["@r"];

	/*realizo la consulta para obtener el orden de las alternativas al azahar*/
	$cnalter = "select ".csc($fcdb2["tb"],$fcdb2["c1"]).", ".csc($fcdb2["tb"],$fcdb2["c2"]).", ".csc($fcdb2["tb"],$fcdb2["c5"]). ", ".csc($fcdb2["tb"],$fcdb2["c4"])." from ".$fcdb2["tb"]." where ".csc($fcdb2["tb"],$fcdb2["c3"])." = '".$fordt[$nval]."' order by rand()";
	$ejc=$bd->ListarDatos($cnalter);

	/*Cuento la cantidad de registros que obtuve de la consulta*/
	$reg=mysql_num_rows($ejc);

	/*Realizo un bucle el cual ira generando numeros hasta un limite de 3 numeros comenzando por el cero
	y ademas verificando que estos numeros no se repitan*/
	for($j=1;$j<=3;$j++){
		/*Genero un numero al azahar*/
		$ntmp=rand(1, 3);
		/*Realizo un bucle que comprueba que el numero no se repita*/
		while(in_array($ntmp, $azalt)) {
			/*Si se repite, generara otro numero y volvera al bucle*/
			$ntmp=rand(1, 3);
		}
			/*De lo contrario, si no se repite, sera asignado al array*/
			$azalt[$j]=$ntmp;
	}

	/*recorro la cantidad de alternativas obtenidas de la db*/	
	for($i=0;$i<=($reg);$i++){
		/*Voy obteniendo alternativas al azahar desde 1 hasta llegar a 3 como maximo, esto debido a q solo las alternativas
		con codigo 1 y 3 son alternativas con procedure, la alternativa 4 es la que verifica si las otras alternativas con
		procedures tienen respuesta correcta, de ser asi, esta ultima alternativa arroja valor "1"*/
		if($i < 4) {
			/*Voy recorriendo todos los registros devueltos por la consulta*/
			$arrayreg2=mysql_fetch_array($ejc);
		}else {
			/*De lo contrario establesco el siguiente valor en la variable*/
			$arrayreg2[$fcdb2["c2"]]='5';
		}
		/*Inicializo el selector del tipo de alternativa, si son de tipo normal o verificador o solo texto, recordar que
		las alternativas tienen un tipo, algunos son de tipo 1 hasta 3 los cuales dan alternativas con procedures, o del
		tipo 4 que son procedures que verifican la pregunta, o del tipo 0 que son solo cadenas de texto*/
		switch(true){
			/*En caso de ser tipo 1 hasta el 3 "alternativa con procedure"*/
			case ($arrayreg2[$fcdb2["c2"]] >= "1" && $arrayreg2[$fcdb2["c2"]] <= "3"):
				/*realizo la construccion de la cadena con el procedure a ejecutar, primero
				evaluo si lleva parametro*/
				if ($arrayreg2[$fcdb2["c4"]]==1){
					/*De ser asi contruyo la cadena con parametro que es el dni*/
					$cejc0 = "call ". $arrayreg2[$fcdb2["c5"]] . "('" . $fdni . "',@r)";
				/*de lo contrario contruyo la cadena sin parametro*/
				}else{
					$cejc0 = "call ". $arrayreg2[$fcdb2["c5"]] . "(@r)";
				}
				/*ejecuto la primera parte del procedure el procedure*/
				$bd->ListarDatos($cejc0);
				/*Construyo la segunda cadena de consulta para los procedures*/
				$cejc1="select @r";
				/*Ejecuto segunda parte del procedure consulta*/
				$arrayreg3=mysql_fetch_array($bd->ListarDatos($cejc1));
				/*asigno resultado de la consulta a array que retornara valor*/
				$arralts[$azalt[$arrayreg2[$fcdb2["c2"]]]] = $arrayreg3["@r"];

				/*Asigno la alternativa con la respuesta correcta, este valor se usara para realizar el seguimiento al cliente,
				primero evaluo si nos encontramos en el orden 1 de las alternativas, ya que la alternativa 1 es por lo general la correcta,
				y ademas me aseguro que la alternativa tenga respuesta correcta con el resultado del procedure verificador*/
				if($arrayreg2[$fcdb2["c2"]]=="1" && $creval == 1){
					/*De ser asi asigno el valor*/
					$arralts['0']=$arrayreg3["@r"];
					/*Establezco el codigo de la alternativa correcta, esta sera el codigo que se usara
					para comparar finalmente la alternativa seleccionada por el cliente*/
					$arralts['7']=$azalt[$arrayreg2[$fcdb2["c2"]]];
				}
				/*Asigno el codigo de la alternativa, si se observa esta sentencia, se repite la misma variable
				2 veces,esto es porque en la posicion de la variable tendremos que poner el valor, para que
				coincida con el valor de las alternativas y el codigo de pregunta, por eso esta variable define
				la posicion y el valor por eso se repite*/
				$arralts['6'][$azalt[$arrayreg2[$fcdb2["c2"]]]]=$azalt[$arrayreg2[$fcdb2["c2"]]];
				break;
			/*En caso sea alternativa del tipo 4 "Solo A y B, solo B y C, solo C Y D"*/
			case ($arrayreg2[$fcdb2["c2"]] == "4"):
				/*Preparo sentencia para alternativa 4*/
				$cejc1 = "select ".csc($fcdb2["tb"],$fcdb2["c2"]).", ".csc($fcdb2["tb"],$fcdb2["c5"])." from ".$fcdb2["tb"]." where ".csc($fcdb2["tb"],$fcdb2["c3"])." >=8 and ".csc($fcdb2["tb"],$fcdb2["c3"])." <=10 order by rand() limit 1";
				/*Ejecuto consulta*/
				$arrayreg3=mysql_fetch_array($bd->ListarDatos($cejc1));
				/*asigno resultado de la consulta a array que retornara valor*/				
				$arralts[$arrayreg2[$fcdb2["c2"]]] = $arrayreg3[$fcdb2["c5"]];
				/*Asigno el codigo de la alternativa*/
				$arralts['6']['4']=$arrayreg2[$fcdb2["c2"]];
				break;
			/*En caso sea alternativa del tipo 5 "Ninguna de las anteriores*/
			case ($arrayreg2[$fcdb2["c2"]] == "5"):
					/*Evaluo la respuesta arrojada por el procedure verificador si fue distinta de 1, entonces no hay repuesta
					correcta, por lo tanto construyo la cadena para mostrar solo "ninguna de las anteriores"*/
				if ($creval != 1){
					/*Preparo sentencia para alternativa 5*/
					$cejc1 = "select ".csc($fcdb2["tb"],$fcdb2["c2"]).", ".csc($fcdb2["tb"],$fcdb2["c5"])." from ".$fcdb2["tb"]." where ".csc($fcdb2["tb"],$fcdb2["c3"])." = '6' limit 1";
				/*De lo contrario, entonces si existe respuesta correcta, asi que puedo construir cadena con opcciones "ninguna
				de las anteriores" y " todas las anteriores"*/	
				}else{
					$cejc1 = "select ".csc($fcdb2["tb"],$fcdb2["c2"]).", ".csc($fcdb2["tb"],$fcdb2["c5"])." from ".$fcdb2["tb"]." where ".csc($fcdb2["tb"],$fcdb2["c3"])." >= '6' and ".csc($fcdb2["tb"],$fcdb2["c3"])." <= '7' order by rand() limit 1";
				}
				/*Ejecuto consulta*/
				$arrayreg3=mysql_fetch_array($bd->ListarDatos($cejc1));
				/*asigno resultado de la consulta a array q retornara alternativas*/
				$arralts[$arrayreg2[$fcdb2["c2"]]] = $arrayreg3[$fcdb2["c5"]];
				/*Asigno el codigo de la alternativa*/
				$arralts['6']['5']=$arrayreg2[$fcdb2["c2"]];
				
				/*Asigno la alternativa con la respuesta correcta, este valor se usara para realizar el seguimiento al cliente,
				primero evaluo si nos encontramos en el orden 1 de las alternativas, ya que la alternativa 1 es por lo general la correcta,
				y ademas me aseguro que la alternativa tenga respuesta correcta con el resultado del procedure verificador*/
				if($arrayreg2[$fcdb2["c2"]]=="5" && $creval != 1){
					/*De ser asi asigno el valor*/
					$arralts['0']=$arrayreg3[$fcdb2["c5"]];
					/*Establezco el codigo de la alternativa correcta, esta sera el codigo que se usara
					para comparar finalmente la alternativa seleccionada por el cliente*/
					$arralts['7']=$arrayreg2[$fcdb2["c2"]];
				}
				break;
		}
/*Activar solo para depurar*/
//$tester=$tester . $cejc0 . $cejc1 . $creval . $cevalprocV . '||||';
//$tester2=$tester2 . $arrayreg2[$fcdb1["c2"]];
	}
/*$arralts['0'] este contiene el texto de la respuesta del cliente, se creo para el panel, para que pueda visualizar
la persona que tenga el panel, cual es la respuesta verdadera, $arralts['6'] tiene los codigos de las pregunta que seran
asignados a los radiobuttons, $arralts['7'] tiene el codigo de la respuesta correcta, este codigo sea asignado al radiobutton
finalmente este se usara para comparar con la alternativa que marco el cliente*/

/*Activar solo para depurar*/
//$arralts['10']=$tester;
//$arralts['11']=$tester2;
	return $arralts;
}

/*fin funciones preguntas y alternativas*/

/**************************************/
/*inicio funciones validacion registro*/
/**************************************/

/*Funcion que realiza la validacion de todos los campos segun los 3 conceptos basicos
de la seguridad que son: "campo vacio, caracteres permitidos y longitud". Adicionalmente
tiene una validacion mas opccional: "diferente de", es decir evalua si la variable es
diferente de algun valor que nosotros deseamos (por ejemplo para comparar contraseña coincide 2
veces en registro). Recibe 4 parametros los cuales son 3 arrays y una variable que contienen lo siguiente:
* El primero es un array con los campos a evaluar.
* El segundo es un array con los valores para comparar segun las validaciones osea que como tenenmos
  3 validaciones mas una opccional, este array tendra 4 campos los cuales seran:
	- Valor a comprarar si es igual (generalmente usado para comparar si vacio).
	- Caracteres permitidos, este valor sera una cadena en forma de expresion regular que le dira a la
	  los caracteres permitidos para la variable a evaluar.
	- Rango, este array tendra sub valores los cuales seran:
		1.- rango minimo de caracteres (un numero).
		2.- rango maximo de caracteres (un numero).
	- Valor a comparar si no es igual (generalmente usado para comparar que las contraseñas coinciden en el registro)
* El tercero es un array con los valores de error que se asignaran a las variables de sesion.
Retorna una variable de sesion con el campo evaludado (ideal para formularios en donde los campos digitados
por el usuario, al regresar a la pagina, esta debe recordarlos).
* El cuarto es el nombre que tendra la variable de sesion, la cual contiene, el contenido de los campos que fueron
pasando las validaciones correctamente, esto con el fin de poder recordar los valores que fue introduciendo el
usuario en el formulario y que son correctos.
Finalmente retorna true si todos las validaciones se pasaron correctamente*/
function vldcmp2($cmps,$vlrs,$emsg,$nvar){
	/*Declaramos contador*/
	$h=0;
//	Declaro variable que acumula errores*/
//	$err="";
	/*Declaramos for que recorrera cada elemento del array*/
	foreach($cmps as $eval){
		/*Primera validacion, evaluo si esta validacion esta activada, y realizo la validacion
		"si es igual al valor no deseado"*/
		if ($vlrs[$h]["0"]["0"] == "act" && $eval == $vlrs[$h]["0"]["1"] || $eval == $vlrs[$h]["0"]["2"]){ 
			/*Establezco mensaje de error, primero evaluo si esta establecido*/
			if(isset($emsg[$h]["0"])){
				/*si es asi, lo establezco*/
				msg($emsg[$h]["0"]);
				/*Limpio la variable de sesion con el valor evaluado, primero evaluo si esta establecido*/
				//if(isset($_SESSION["evalrg"][$h])){
				if(isset($_SESSION[$nvar][$h])){
					/*De se asi dejo su valor en blanco*/
					$_SESSION[$nvar][$h]="";
					/*Antigua forma de dejar en blanco la variable evaluada, pero aun puede servir por eso lo dejo*/
					$_SESSION["evalrg"][$h]="";
				}
				/*Retorno false*/
				return false;
//				$err++;
			}
		/*De lo contrario si segunda validacion "caracteres permitidos"*/	
		}elseif(!scar($eval,$vlrs[$h]["1"])){
			/*Establezco mensaje de error, primero evaluo si esta establecido*/
			if(isset($emsg[$h]["1"])){
				/*si es asi, lo establezco*/
				msg($emsg[$h]["1"]);
				/*Limpio la variable de sesion con el valor evaluado, primero evaluo si esta establecido*/
				//if(isset($_SESSION["evalrg"][$h])){
				if(isset($_SESSION[$nvar][$h])){
					/*De se asi dejo su valor en blanco*/
					$_SESSION[$nvar][$h]="";
					/*Antigua forma de dejar en blanco la variable evaluada, pero aun puede servir por eso lo dejo*/
					$_SESSION["evalrg"][$h]="";
				}
				/*Retorno false*/
				return false;
//				$err++;
			}
		/*De lo contrario si tercera validacion "longitud"*/	
		}elseif(strlen($eval)<$vlrs[$h]["2"]["0"] || strlen($eval)>$vlrs[$h]["2"]["1"]){
			/*Establezco mensaje de error, primero evaluo si esta establecido*/
			if(isset($emsg[$h]["2"])){
				/*si es asi, lo establezco*/
				msg($emsg[$h]["2"]);
				/*Limpio la variable de sesion con el valor evaluado, primero evaluo si esta establecido*/
				//if(isset($_SESSION["evalrg"][$h])){
				if(isset($_SESSION[$nvar][$h])){
					/*De se asi dejo su valor en blanco*/
					$_SESSION[$nvar][$h]="";
					/*Antigua forma de dejar en blanco la variable evaluada, pero aun puede servir por eso lo dejo*/
					$_SESSION["evalrg"][$h]="";
				}
				/*Retorno false*/
				return false;
//				$err++;
			}
		/*De lo contrario, evaluo si validacion 3 esta activada, y realizo la validacion "direfente"*/
		}elseif($vlrs[$h]["3"]["0"] == "act" && $eval != $vlrs[$h]["3"]["1"]){
			/*Establezco mensaje de error, primero evaluo si esta establecido*/
			if(isset($emsg[$h]["3"])){
				/*si es asi, lo establezco*/
				msg($emsg[$h]["3"]);
				/*Limpio la variable de sesion con el valor evaluado, primero evaluo si esta establecido*/
				//if(isset($_SESSION["evalrg"][$h])){
				if(isset($_SESSION[$nvar][$h])){
					/*De se asi dejo su valor en blanco*/
					$_SESSION[$nvar][$h]="";
					/*Antigua forma de dejar en blanco la variable evaluada, pero aun puede servir por eso lo dejo*/
					$_SESSION["evalrg"][$h]="";
				}
				/*Retorno false*/
				return false;
//				$err++;
			}
		}
	/*Retorno el valor evaluado en variable de sesion*/
	$_SESSION[$nvar][$h]=$eval;
	/*Antigua forma de regresar la variable evaluada, pero aun puede servir por eso lo dejo*/
	$_SESSION["evalrg"][$h]=$eval;
	/*Aumentamos contador en uno*/
	$h++;
	}
	/*Si todo paso retorno verdadero*/
	return true;
}
/*Puede funcionar en 2 modalidades, individual y en grupo, es decir:
Modalidad invidivual:
Nosotros podemos hacer un bucle que recorra todos los valores enviados por el usuario e ir
comparando cada valor con cada array de validaciones especifico para cada valor enviado.
Modalidad en grupo:
Nosotros podemos crear un array que tenga los valores enviados por el usuario y comparar cada
valor con un solo array de validaciones definidos que se aplicaria a todos los valores.
Aun no se bien la ventaja pero dejo abierta las 2 posibilidades*/
function vldcmp($cmps,$vldcn,$emsg){
	/*Declaramos contador*/
	$h=0;
	/*Para cada campo*/
	foreach($cmps as $eval){
		/*Para cada validacion*/
		foreach($vldcn as $llav=>$val){
			/*Evaluamos el contador para saber en que validacion estamos*/
			switch($llav){
				/*Caso primera validacion "igual a valor no deseado"*/
				case 0:
					if(isset($vldcn[$llav]) && $eval == $vldcn[$llav]){
						/*Establezco mensaje de error, primero evaluo si esta establecido*/
						if(isset($emsg[$llav]) && $emsg[$llav] != ""){
							/*si es asi, lo establezco*/
							msg($emsg[$llav]);
						}
						return false;
					}
				break;
				/*Caso segunda validacion "igual a valor no deseado"*/
				case 1:
					if(isset($vldcn[$llav]) && $eval == $vldcn[$llav]){
						/*Establezco mensaje de error, primero evaluo si esta establecido*/
						if(isset($emsg[$llav]) && $emsg[$llav] != ""){
							/*si es asi, lo establezco*/
							msg($emsg[$llav]);
						}
						return false;
					}
				break;
				/*Caso tercera validacion "caracteres permitidos"*/
				case 2:
					if(isset($vldcn[$llav]) && !scar($eval,$vldcn[$llav])){
						/*Establezco mensaje de error, primero evaluo si esta establecido*/
						if(isset($emsg[$llav]) && $emsg[$llav] != ""){
							/*si es asi, lo establezco*/
							msg($emsg[$llav]);
						}
						return false;
					}
				break;
				/*Caso cuarta validacion "longitud"*/
				case 3:
					/*Para evaluar este caso y debido a que este caso ocupa 2 posiciones se toma el valor de
					el contador primero en nueva variable*/
					$f=$llav;
					/*finalmente se evalua*/
					if(isset($vldcn[$f]) && (strlen($eval)<$vldcn[$f] || strlen($eval)>$vldcn[($f+1)])){
						/*Establezco mensaje de error, primero evaluo si esta establecido*/
						if(isset($emsg[$f]) && $emsg[$f] != ""){
							/*si es asi, lo establezco*/
							msg($emsg[$f]);
						}
						return false;
					}
				break;
				/*Caso sexta validacion "diferente de"*/
				case 5:
					if((isset($vldcn[$llav]) && $eval != $vldcn[$llav])){
						/*Establezco mensaje de error, primero evaluo si esta establecido*/
						if(isset($emsg[$llav]) && $emsg[$llav] != ""){
							/*si es asi, lo establezco*/
							msg($emsg[$llav]);
						}
						return false;
					}
				break;
			}
		}
	}
	/*Si todo paso retorno valor evaluado*/
	return $eval;
}


/***********************************/
/*fin funciones validacion registro*/
/***********************************/

/*******************************************/
/*inicio funciones validacion inicio sesion*/
/*******************************************/

/*Funcion que rellena los combobox, con opccion de definir la  primera y ultima opccion, recibe
8 parametros, los 2 primeros corresponden al primer y ultimo parametro del combo, la tercera
corresponde a la opccion seleccionada del combo, la cuarta es la cadena de consulta que se usara
para consultar a la db y obtener los valores del combo (si no se desea trabajar con la db, se entiende
que se quiere trabajar en el modo sin db, por lo tanto esta variable tendra que establecerse como un array
que tenga todos los valores del combo), la quinta el tipo de combobox que deseamos (debido a que hay dos
tipos de combo posibles, el combo asociativo en el cual tanto el codigo del item como el mismo item que se
muestra al usuario tienen el mismo valor osea el mismo texto, y el combo con codigo, en el cual cada item
tiene un codigo como valor y lo que se le muestra al cliente es la descripccion del item, que es muy distinto
al valor) tiene 2 valores "a" es combo asociativo y "c" combo con codigo, la sexta es el nombre de la
cabecera de la columna devuelta por la consulta especificada en el cuarto parametro, este nombre de cabecera
se utilizara para recorrer los elementos devueltos por esta consulta, sin esto no seria posible obtener los
elementos, si trabajamos en el modo sin db, dejar esta como una cadena en blanco "", la septima el nombre de
una segunda cabecera devuelta por la consulta especificada tambien en el cuarto parametro, esto se aplica en
caso de que tengamos codigos asociados a cada objeto que finalmente es una opccion del combo en la db, es por
este motivo que la segunda cabecera es util para obtener estos codigos devueltos por la consulta (si se desea
que la funcion asigne codigos de numeros consecutivos, establecer esta variable con valor "consecutivo", y si
no se desea que hayan codigos, dejar esta variable en blanco, si se activo la opccion sin db, establecer esta
variable como un array que contenga los codigos para cada valor del combo), y la octaba la cadena de conexion
a la db*/
function rll_cb2($p_opt,$u_opt,$sel,$cad_cns,$tc,$ncmp,$ncmpc,$cnx){
	/*necesario para la conexion a la base de datos, primero evaluamos que este establecida*/
	if(isset($cnx) && $cnx != ""){
		/*Incluimos la conexion*/
		include ($cnx);
		/*Creamos la clase a partir del constructor*/
		$bd = new datos();
	}

	/*Declaramos array que tendra el contenido de los combos*/
	$cbopcc=array();

	/*Evaluamos la variable $cad_cns la cual dependiendo del modo en que usemos la funcion puede variar
	entre "modo con db y sin db", si es con db, esta variable tendria la cadena de consulta, si es sin
	db, esta variable seria un array con los elementos para llenar el combo, para ello evaluamos si la
	variable es un array*/
	if(is_array($cad_cns)){
		/*Si es array, se activara el modo sin db, el cual obtiene los elementos del combo,
		del array "cad_cns", que se le pase a la funcion con los valores, para ello se usara
		la misma variable de la cadena pero evaluada como array*/
		$opcc=$cad_cns;
		/*Establecemos el codigo para cada elemento del combo*/
		$cdopt=$ncmpc;
	/*De lo contario si no es array y no es vacio entonces se activa el modo con db, en la cual la variable
	$cad_cns" tendra la consulta para realizar a la db y obtener los valores*/
	}elseif($cad_cns!=""){

		/*Si la cadena de consulta a la db existe la ejecutamos*/
		$con_cns=$bd->ListarDatos($cad_cns);

		/*Creamos el array que contendra los datos recogidos por la consulta*/
		$cns=array();

		/*Declaramos array que tendra los resultados recorridos de la variable que obtubo datos de la consulta*/
		$opcc=array();

		/*Declaramos array que tendra los resultados del codigo de cada opccion mostrada en el combo procedentes de la consulta*/
		$cdopt=array();

		/*Declaramos contador*/
		$g='0';
		/*Recorremos los datos arrojados por la variable*/
		while($cns=mysql_fetch_assoc($con_cns)) {
			/*Asignamos el valor a variable correspondiente a la cabecera 1*/
			$opcc[$g]=$cns[$ncmp];
			/*Asignamos el valor a array temporal correspondiente a la cabecera 2, primero
			evaluamos que el array se encuentre establecido osea que se activo esta opccion*/
			if(isset($ncmpc) && $ncmpc == "consecutivo"){
				/*dejamos codigos con numeros consecutivos*/
				$cdopt[$g]=$g;
			/*De lo contrario si no se activo la opccion consecutivo y no es vacio*/
			}elseif(isset($ncmpc) && $ncmpc != ""){
				/*De ser asi, asignamos el valor correspondiente al codigo*/
				$cdopt[$g]=$cns[$ncmpc];
			/*de lo contrario*/
			}else{
				/*dejamos los codigos con vacio*/
				$cdopt[$g]="";
			}
			/*Aumentamos el contador en 1*/
			$g++;
		}
	}



	/*Declaramos contador*/
	$c='0';

	/*Contamos la cantidad de objetos que tiene la variable*/
	$cntd=count($opcc);

	/*vamos asignando los valores obtenidos de la db*/
//	foreach($opcc as $cboptb){
	foreach($opcc as $cod=>$cboptb){
		/*Evaluamos si existen posiciones, de ser asi vamos corrigiendo el array*/
		switch($cboptb) {
			/*Si existe la primera posicion, la agregamos como primera en el array*/
			case $p_opt:
				/*Verificamos si se trata de un combo asociativo o un combobox con codigo*/
				switch($tc) {
					/*En caso de que se trate de un combobox asociativo*/
					case "a":
						/*Evaluamos si esta opcion fue seleccionada*/
						if(isset($sel) && $sel==utf8_encode($cboptb)){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cboptb) . "' selected>" . utf8_encode($cboptb) ."</option>\012";
						/*De lo contrario evaluamos si no hay opccion seleccionada lo que quiere decir que es la opccion por dececto*/
						}elseif($sel==""){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cboptb) . "' selected>" . utf8_encode($cboptb) . "</option>\012";				
						}else{
							/*De lo contrario la dejamos sin seleccionar*/
							$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cboptb) . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Asignamos codigo de cada elemento especificado por segunda cabecera, primero
						Evaluamos si se trata del modo con db o sin db, para ello evaluamos la cadena de conexion*/
						if(is_array($cad_cns)){
							/*Si es un array, osea el modo sin db, asignamos el codigo del primer elemento como cero y como valor
							el nombre del objeto que le corresponde*/
							$cbopcc["c"]["0"]=$cdopt["0"];
						}else{
							/*De lo contrario, establecemos el codigo del primer elemento con el primer valor correspondiente a los
							codigos obtenido de la db*/
							$cbopcc["c"][utf8_encode($cboptb)]=$cdopt["0"];
						}
						break;
					/*En caso de que se trate de un combobox con codigo*/
					case "c":
						/*Evaluamos si esta opcion fue seleccionada*/
						if(isset($sel) && $sel==$c){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"]['0']="													<option value='" . $c . "' selected>" . utf8_encode($cboptb) ."</option>\012";
						/*De lo contrario evaluamos si no hay opccion seleccionada lo que quiere decir que es la opccion por dececto*/
						}elseif($sel==""){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"]['0']="													<option value='" . $c . "' selected>" . utf8_encode($cboptb) . "</option>\012";				
						}else{
							/*De lo contrario la dejamos sin seleccionar*/
							$cbopcc["cb"]['0']="													<option value='" . $c . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Asignamos codigo de cada elemento especificado por segunda cabecera, primero
						evaluamos si se trata del modo con db o sin db, para ello evaluamos la cadena de conexion*/
						if(is_array($cad_cns)){
							/*Si es un array, osea el modo sin db, asignamos el codigo del primer elemento como cero y como valor
							el nombre del objeto que le corresponde*/
							$cbopcc["c"]["0"]=$cdopt["0"];
						}else{
							/*De lo contrario, establecemos el codigo del primer elemento con el primer valor correspondiente a los
							codigos obtenido de la db*/
							$cbopcc["c"][$c]=$cdopt["0"];
						}
						break;
				}
				/*Aumentamos uno al contador*/
				$c++;							
				break;
			/*Si existe la ultima posicion, la agregamos como ultima en el array*/
			case $u_opt:
				/*Restamos uno a la variable que tiene la cantidad de objetos*/
				$cntd=$cntd-1;
				/*Declaramos variable que alamacenara el resultado de los codigos*/
				$cd="";
				/*Verificamos si se trata de un combo asociativo o un combobox con codigo*/
				switch($tc) {
					/*En caso de que se trate de un combobox asociativo*/
					case "a":
						/*Evaluamos si esta opccion fue seleccionada*/
						if(isset($sel) && $sel==utf8_encode($cboptb)){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"][$cntd]="													<option value='" . utf8_encode($cboptb) . "' selected>" . utf8_encode($cboptb) . "</option>\012";
						}else{
							/*De lo contrario la dejamos por defecto*/
							$cbopcc["cb"][$cntd]="													<option value='" . utf8_encode($cboptb) . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Agisnamos codigo de cada elemento especificado por segunda cabecera2, para realizar
						esto, recorremos el array con las opcciones para buscar la coincidencia con la ultima opccion*/
						foreach ($opcc as $clave=>$valor) {
								/*Evaluamos si el valor recorrido coincide con el valor de la ultima opccion definida*/
								if($valor==$u_opt) {
									/*Si es asi, obtenemos la clave del valor y lo asignamos a variable*/
									$cd=$clave;
								}
							}
						/*Luego con la clave obtenida podremos fijar el valor para ese codigo correspondiente
						al objeto de la primer resultado de la cabecera1*/
						$cbopcc["c"][utf8_encode($cboptb)]=$cdopt[$cd];
						break;
					/*En caso de que se trate de un combobox con codigo*/
					case "c":
						/*Evaluamos si esta opccion fue seleccionada*/
						if(isset($sel) && $sel==$cntd){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"][$cntd]="													<option value='" . $cntd . "' selected>" . utf8_encode($cboptb) . "</option>\012";
						}else{
							/*De lo contrario la dejamos por defecto*/
							$cbopcc["cb"][$cntd]="													<option value='" . $cntd . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Agisnamos codigo de cada elemento especificado por segunda cabecera2, para realizar
						esto, recorremos el array con las opcciones para buscar la coincidencia con la ultima opccion*/
						foreach ($cdopt as $clave=>$valor) {
								/*Evaluamos si el valor recorrido coincide con el valor de la ultima opccion definida*/
								if($clave==$cod) {
									/*Si es asi, obtenemos la clave del valor y lo asignamos a variable*/
									$cd=$clave;
								}
							}
						/*Luego con la clave obtenida podremos fijar el valor para ese codigo correspondiente
						al objeto de la primer resultado de la cabecera1*/
						$cbopcc["c"][$cntd]=$cdopt[$cd];
						break;
				}
				break;
			/*De lo contrario evaluamos la misma variable para continuar con el recorrido de las opcciones*/
			case $cboptb:
				/*declaramos variable que alamacenara el resultado del codigo*/
				$cd="";
				/*Verificamos si se trata de un combo asociativo o un combobox con codigo*/
				switch($tc) {
					/*En caso de que se trate de un combobox asociativo*/
					case "a":
						/*Evaluamos si alguna de las opcciones fue seleccionada*/
						if(isset($sel) && $sel==utf8_encode($cboptb)){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"][$c]="													<option value='" . utf8_encode($cboptb) . "' selected>" . utf8_encode($cboptb) . "</option>\012";
						}else{
							/*De lo contrario la dejamos por defecto*/
							$cbopcc["cb"][$c]="													<option value='" . utf8_encode($cboptb) . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Agisnamos codigo de cada elemento especificado por segunda cabecera2, para realizar
						esto primero recorremos el array con las opcciones para buscar la coincidencia con la opccion del combo*/
						foreach ($opcc as $clave=>$valor) {
								/*Evaluamos si el valor recorrido coincide con el valor de la ultima opccion definida*/
								if($valor==utf8_encode($cboptb)) {
									/*Si es asi, obtenemos la clave del valor y lo asignamos a variable*/
									$cd=$clave;
								}
							}
						/*Luego con la clave obtenida podremos fijar el valor para ese codigo correspondiente
						al objeto de la primer resultado de la cabecera1*/
						$cbopcc["c"][utf8_encode($cboptb)]=$cdopt[$cd];
						break;
					/*En caso de que se trate de un combobox con codigo*/
					case "c":
						/*Evaluamos si alguna de las opcciones fue seleccionada*/
						if(isset($sel) && $sel==$c){
							/*Si es asi la seleccionamos*/
							$cbopcc["cb"][$c]="													<option value='" . $c . "' selected>" . utf8_encode($cboptb) . "</option>\012";
						}else{
							/*De lo contrario la dejamos por defecto*/
							$cbopcc["cb"][$c]="													<option value='" . $c . "'>" . utf8_encode($cboptb) . "</option>\012";
						}
						/*Agisnamos codigo de cada elemento especificado por segunda cabecera2, para realizar
						esto primero recorremos el array con las opcciones para buscar la coincidencia con la opccion del combo*/
						foreach ($cdopt as $clave=>$valor) {
								/*Evaluamos si el valor recorrido coincide con el valor de la ultima opccion definida*/
								if($clave==utf8_encode($cod)) {
									/*Si es asi, obtenemos la clave del valor y lo asignamos a variable*/
									$cd=$clave;
								}
							}
						/*Luego con la clave obtenida podremos fijar el valor para ese codigo correspondiente
						al objeto de la primer resultado de la cabecera1*/
						$cbopcc["c"][$c]=$cdopt[$cd];
						break;
				}
				/*Aumentamos el contador en uno*/
				$c++;				
				break;
		}
	}
	/*Retornamos el array deseado*/
/*Activar solo para Debug*/
/*$_SESSION["test"]=$cod;
$_SESSION["test0"]=$cboptb;
$_SESSION["test1"]=$opcc;
$_SESSION["test2"]=$cdopt;*/
	return $cbopcc;
}

/*Funcion que construye solo las opcciones del combo y deja listo para recorrerlas con un bucle,
tambien arma un segundo array con los codigos reales asociados a cada opccion del combo
Recibe 7 parametros:
1er parametro: texto de la primera opccion del combo seleccionado, ojo que este texto debe existir
en el array de donde se sacaran las opcciones o en el resultado de la consulta de la db.
2do parametro: texto de la ultima opccion del combo seleccionado, ojo que este texto debe existir
en el array de donde se sacaran las opcciones o en el resultado de la consulta de la db.
3er parametro: opccion seleccionada del combo, ojo que este texto debe existir
en el array de donde se sacaran las opcciones o en el resultado de la consulta de la db.
4to parametro: array o cadena de consulta que tendra las opcciones del combo.
5to parametro: tipo de combo, se contemplan 2 opcciones "aso" y "cod" se entiende que en el asociativo
tanto las opcciones como el codigo del combo seran lo mismo, en el caso sea codigo, las opcciones
seran texto y el codigo, seran codigos asociados a estas opcciones.
6to parametro: array que tendra los codigos asociados a cada opccion de combo o nombre de la segunda
cabecera devuelta por la consulta a la db, que tiene los codigos de las opcciones del combo, ojo que
no necesariamente tiene que ser el nombre exacto de la segunda cabecera, ya que la funcion obtiene este
nombre de la consulta propiamente. 
7mo parametro: cadena de conexion a la db*/
function rll_cb($p_opt,$u_opt,$sel,$objs,$tc,$ncmpc,$cnx){
	/*necesario para la conexion a la base de datos, primero evaluamos que este establecida*/
	if(isset($cnx) && $cnx != ""){
		/*Incluimos la conexion*/
		include ($cnx);
		/*Creamos la clase a partir del constructor*/
		$bd = new datos();
	}

	/*Declaramos array que tendra cada objeto del combo*/
	$opcc=array();
	/*Declaramos array que tendra cada codigo de objeto del combo*/
	$cdopcc=array();
$test="";
	/*Evaluamos la variable $objs la cual dependiendo del modo en que usemos la funcion puede variar
	entre "modo con db y sin db", si es con db, esta variable tendria la cadena de consulta, si es sin
	db, esta variable seria un array con los elementos para llenar el combo, para ello evaluamos si la
	variable es un array*/
	if(is_array($objs)){
		/*Si es array, se activara el modo sin db, y se utiliza esta variable para definir los objetos del combo*/
		$opcc=$objs;
	/*De lo contario si no es array y no es vacio entonces se activa el modo con db, en la cual la variable
	$cad_cns" tendra la consulta para realizar a la db y obtener los valores*/
	}elseif($objs!=""){
		/*Ejecutamos la cadena de consulta contra la db*/
		$con_cns=$bd->ListarDatos($objs);
		/*Creamos el array que contendra los datos recogidos por la consulta*/
		$cns=array();
		/*Declaramos array que tendra los resultados obtenidos del array de cosulta pero transformados en numerico*/
		$rcns=array();
		/*Declaramos variable que tendra el nombre de la cabecera del primer obheto del array*/
		$ind="";
		$coddb="";
		/*Declaramos array que tendra solo el primer valor de la consulta, esto en caso de que la consulta tenga mas
		de 2 columnas*/
		$opcc=array();
		/*Declaramos contador*/
		$h=0;
		/*Recorremos array con resultado de la consulta NOTA: si se especifico en la cadena de consulta una segunda
		cabecera, esta nueva variable tambien tendra 2 valores por cada elemento correspondiente a las 2 cabeceras,
		se entiende que la primera cabecera son los objetos y la segunda los codigos*/
		while($cns=mysql_fetch_assoc($con_cns)) {
			/*Asignamos los valores a nueva variable*/
			$rcns[]=$cns;
			/*Obtenemos el valor de cada primer registro del array, es decir, el array tendra por cada registro
			dos valores, nosotros solo tomaremos el valor del primer elemento de cada registro, debido a que es
			un combo asociativo, la consulta no devueve valores numericos para poder obtener dicho valor, asi que
			tendremos que hacer un truco, primero tendremos que obtener el codigo o indice del primer valor del
			registro en que nos encontremos y en base a ese indice o codigo, obtendremos el valor del registro
			en el que nos encontremos*/
			$opcc[$h]=$rcns[$h][key($rcns[$h])];
			/*Aumentamos contador en 1*/
			$h++;
		}
		/*Obtenemos nombre de la cabecera del primer objeto del array, solo es necesario la primera
		cabecera debido a que el nombre de esta cabecera es la misma en todos los objetos del array
		por lo tanto, al obtener la primera la podremos usar en todos los objetos NOTA: key devuelve
		solo el indice del primer elemento del array siempre*/
		$ind=key($rcns["0"]);
		/*Si esta establecida la segunda posicion del array, avanzamos hasta esa posicion*/
		if(next($rcns["0"])){
			/*Devolvemos el valor correspondiente a la cabecera de la segunda posicion del array*/
			$coddb=key($rcns["0"]);
			/*Retrocedemos a la posicion anterior del array*/
			prev($rcns["0"]);
		}
	}

	/*Declaramos contador*/
	$g='0';
	/*Recorremos cada opccion encontrada*/
	foreach($opcc as $val){
		/*Evaluamos el tipo de combo*/
		switch($tc){
			/*Combo de codigo, el codigo es distinto de la descipccion del objeto*/
			case "cod":
				/*Si la segunda cabecera es array, se entiende que estos seran los codigos*/
				if(is_array($ncmpc)){
					/*Asignamos cada valor de array de codigos  a variable secundaria de codigos*/
					$cdopcc[]=$ncmpc[$g];
					/*Asignamos codigos reales a segunda variable para evaluar respuesta del cliente*/
					$cbopcc["c"][$g]=$ncmpc[$g];
				/*De lo contrario, si es diferente de vacio, se entiende que es el nombre de la segunda cabecera de la consulta a la db*/
				}elseif($ncmpc != ""){
					/*Asignamos cada valor de la segunda cabecera de la db*/
					$cdopcc[]=$rcns[$g][$ncmpc];
					/*Asignamos codigos reales a segunda variable para evaluar respuesta del cliente*/
					$cbopcc["c"][$g]=$rcns[$g][$ncmpc];
				/*De lo contrario*/
				}else{
					/*asignamos codigos consecutivos*/
					$cdopcc[]=$g;
					/*Asignamos codigos reales a segunda variable pra evaluar respuesta del cliente*/
					$cbopcc["c"][$g]=$g;
				}
				break;
			/*Combo asociativo, el codigo tendra el mismo valor que los objetos*/
			case "aso":
				/*Asignamos el mismo valor que el objeto al codigo*/
				$cdopcc[]=$opcc[$g];
				/*Realizamos evaluacion para asignar segunda variable de codigos, primero evaluamos si
				la segunda cabecera es array*/
				if(is_array($ncmpc)){
					/*Asignamos cada valor de array de codigos  a variable secundaria de codigos*/
					$cbopcc["c"][$opcc[$g]]=$ncmpc[$g];
				/*De lo contrario, si es diferente de vacio, se entiende que es el nombre de la segunda cabecera de la consulta a la db*/
				}elseif($ncmpc != ""){
					/*Asignamos codigos reales a segunda variable para evaluar respuesta del cliente*/
					$cbopcc["c"][$opcc[$g]]=$rcns[$g][$coddb];
				/*De lo contrario*/
				}else{
					$cbopcc["c"][$opcc[$g]]=$g;
				}
				break;
		}
		/*Aumentamos el contador en 1*/
		$g++;
	}
	/*Declaramos contador*/
	$c='0';
	/*Contamos la cantidad de objetos que tiene la variable*/
	$cntd=count($opcc);

	/*vamos asignando los valores obtenidos de la db*/
	foreach($opcc as $cod=>$obj){
		/*Evaluamos si existen posiciones, de ser asi vamos corrigiendo el array*/
		switch($cdopcc[$cod]){
			/*Si existe la primera posicion, la agregamos como primera en el array*/
			case $p_opt:
				/*Evaluamos si esta opcion fue seleccionada*/
				if(isset($sel) && $sel==utf8_encode($cdopcc[$cod])){
					/*Si es asi la seleccionamos*/
					$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cdopcc[$cod]) . "' selected>" . utf8_encode($obj) ."</option>\012";
				/*De lo contrario evaluamos si no hay opccion seleccionada lo que quiere decir que es la opccion por dececto*/
				}elseif($sel==""){
					/*Si es asi la seleccionamos*/
					$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cdopcc[$cod]) . "' selected>" . utf8_encode($obj) . "</option>\012";				
				}else{
					/*De lo contrario la dejamos sin seleccionar*/
					$cbopcc["cb"]['0']="													<option value='" . utf8_encode($cdopcc[$cod]) . "'>" . utf8_encode($obj) . "</option>\012";
				}
				$c++;							
				break;
			case $u_opt:
				/*Restamos uno a la variable que tiene la cantidad de objetos*/
				$cntd=$cntd-1;
				/*Declaramos variable que alamacenara el resultado de los codigos*/
				$cd="";
				/*Verificamos si se trata de un combo asociativo o un combobox con codigo*/
				/*Evaluamos si esta opccion fue seleccionada*/
				if(isset($sel) && $sel==utf8_encode($cdopcc[$cod])){
					/*Si es asi la seleccionamos*/
					$cbopcc["cb"][$cntd]="													<option value='" . utf8_encode($cdopcc[$cod]) . "' selected>" . utf8_encode($obj) . "</option>\012";
				}else{
					/*De lo contrario la dejamos por defecto osea sin seleccionar*/
					$cbopcc["cb"][$cntd]="													<option value='" . utf8_encode($cdopcc[$cod]) . "'>" . utf8_encode($obj) . "</option>\012";
				}
				break;
			/*De lo contrario evaluamos la misma variable para continuar con el recorrido de las opcciones*/
			case $cdopcc[$cod]:
				/*declaramos variable que alamacenara el resultado del codigo*/
				$cd="";
				/*Evaluamos si alguna de las opcciones fue seleccionada*/
				if(isset($sel) && $sel==utf8_encode($cdopcc[$cod])){
					/*Si es asi la seleccionamos*/
					$cbopcc["cb"][$c]="													<option value='" . utf8_encode($cdopcc[$cod]) . "' selected>" . utf8_encode($obj) . "</option>\012";
				}else{
					/*De lo contrario la dejamos por defecto*/
					$cbopcc["cb"][$c]="													<option value='" . utf8_encode($cdopcc[$cod]) . "'>" . utf8_encode($obj) . "</option>\012";
				}
				/*Aumentamos el contador en uno*/
				$c++;
				break;
		}
	}
	$_SESSION["VALORDEPRUEBA"]=$test;
	/*Retornamos el array deseado*/
	return $cbopcc;
}

/*****************************/
/*fin funciones inicio sesion*/
/*****************************/

/*********************/
/*FUNCIONES EN DESUSO*/
/*********************/
function validaInputUsu($vusu,$pros){
	if($vusu == ''){
		/*si el input "casilla" de usuario esta vacio, dependiendo del proceso que llame
		la funcion ejecutamos el mensaje respectivo*/
		switch($pros){
			/*caso para el registro de usuario*/
			case "reg_us":
				msg("reg1_us_vc");
				break;
			/*caso para la autenticacion de usuario*/
			case "aut_us":
			msg("aut_us_in_vc");
			break;
		}		
		return false;
     /*NO cumple longitud minima*/
	}else if(strlen($vusu) < 4 || strlen($vusu) > 20){
		$_SESSION['e-usu'] = 'El usuario debe contener minimo 5 y maximo 20 caracteres ';
		return false;
    //longitud correcta pero NO tiene solo caracteres A-z
	}else if(!preg_match("/^[0-9a-zA-Z]+$/", $vusu)){
		$_SESSION['e-usu'] = 'El usuario debe contener solo letras o adicionalmente numeros ';
		return false;
    // todas las validaciones correctas
	}else{
		return true;
	}
}

function validaContr1_R($contr1_r){
	//NO tiene minimo de 5 caracteres o tiene mas de 20 caracteres
	if(strlen($contr1_r) < 5){
		$_SESSION['e-pass'] = '- La contraseña debe contener minimo 5 caracteres ';
		return false;
	}else if(strlen($contr1_r) > 20){
		$_SESSION['e-pass'] = '- La contraseña debe contener maximo 35 caracteres ';
	// longitud correcta, NO VALIDO numeros y letras
	}else if(!preg_match("/^[0-9a-zA-Z]+$/", $contr1_r)){
		$_SESSION['e-pass'] = '- La contraseña solo puede contener letras y numeros ';
		return false;
	// todas las validaciones correctas
	}else{
		return true;
	}
}

function validaContr2_R($contr1_r, $contr2_r){
	//NO coinciden
	if($contr1_r != $contr2_r){
		$_SESSION['e-pass2'] = '- Las contraseñas ingresadas no coinciden ';
		return false;
	}else{
		return true;
	}
}

function validaCorr_R($corr_r){
	//NO hay nada escrito
	if(strlen($corr_r) < 12 || strlen($corr_r) > 45){
		$_SESSION['e-mail'] = '- El correo electrónico debe contener minimo 12 y maximo 45 caracteres ';
		return false;
	// SI escrito, NO VALIDO email
	}else if(!filter_var($corr_r, FILTER_VALIDATE_EMAIL)){
		$_SESSION['e-mail'] = '- Debe ingregar un correo electrónico válido ';
		return false;
	// SI rellenado, SI email valido
	}else{
		return true;
	}
}

function validaCodseg_R($codseg_r){
	//NO coincide codigo
	if($codseg_r != $_SESSION['cautgen']){
		$_SESSION['e-capt'] = '- El codigo de verificación no coincide ';
		return false;
	//SI codigo coincide
	}else{
		return true;
	}
}

/*funcion que redirecciona en base a un parametro que le pasamos*/
/*function redir($dest){
	switch($dest){
		case "regf":
			header("Location: info.php");
			break;
		case > 18:
			header("Location: info.php");
			break;
		default:
			header("Location: info.php");
			break;
	}
}*/

/*validando formato de nombre de usuario*/
function validaUsu_L($usu_l){
    /*campo de usuario vacio*/
	if($usu_l == ''){
		/*si el input "casilla" de usuario esta vacio, mandamos mensaje
		mencionando que ingrese su nombre de usuario*/
		msg("aut_iv");
		return false;
    /*no cumple con longitud y contiene caracteres especiales, aca volvemos
    a reutilizar la funcion creada para el registro, asi ahorramos recursos*/
   }else if(!validaUsu_R($usu_l)){
		return false;
	}else{
		return true;
	}
}

/*validando formato de contraseña*/
function validaContr_L($contr_l){
    /*campo de contraseña vacio*/
	if($contr_l == ''){
		/*si el input "casilla" de la contraseña esta vacio mandamos mensaje 
		mencionando que ingrese la contraseña*/
		msg("aut_cv");
		return false;
    /*no cumple con longitud y contiene caracteres especiales, aca volvemos
    a reutilizar la funcion creada para el registro, asi ahorramos recursos*/
   }else if(!validaContr1_R($contr_l)){
		return false;
	}else{
		return true;
	}
}

/*idea, estas 2 funciones de validacion de usuario de login no sirven, puesto que
se pueden integrar a las validaciones de registro, si nos fijamos bien, en las validaciones
de registro, no estoy validando si el campo esta vacio, aunque esta de mas porque se valida
si son menores a 5 caracteres, para el usuario es una guia, porque podemos primero validar
si el campo esta vacio y mandar mensaje dicendo que el campo esta vacio y es obligatorio
ya luego si el usuario ingresa solo 2 caracteres como contraesña entonces recien se valida
la longitud, por lo tanto estas dos funciones de arriba se van a fusionar con las otras de 
validacion de registro.
Otra idea estas funciones de validacion de registro deben de ser multifuncion osea
deben recibir un parametro y dependiendo del parametro que reciban, sera el mensaje q
desplegaran para lograr esto se pone que dentro de cada funcion q reciba un parametro
que sera un valor que almacenaremos en una variable, este valor sera nada menos que el
valor que se le aplicara a la funcion msg, entonces si el valor pasado es "aut-iv", se
crearia la variable de sesion "e_usu_l" con el valor porfavor ingrese su nombre de usuario,
si se le pasa "regf-no", crearia la variable de sesion "infcnt1" con valor "Lo sentimo,
desafortunadamente es necesario realizar el proceso de registro..." y asi susesivamente*/

function cambiaEstMenu($Menu){
	if ($Menu == "menDef"){
	$active = 'class="active"';
	}else{
	$active = "none";
	}
	return $active;
}

function validadoc($doc){
	/*NO tiene minimo de 8 caracteres o tiene mas de 20 caracteres*/
	if(strlen($doc) < 5 || strlen($doc) > 20){
		$_SESSION['e-doc'] = '- El DOI debe contener minimo 5 y maximo 20 caracteres ';
		return false;
	}else if(!preg_match("/^[0-9]+$/", $doc)){
		$_SESSION['e-doc'] = '- El DOI debe contener solo números ';
		return false;
	/* todas las validaciones correctas*/
	}else{
		return true;
	}
}

?>
