<?php
include(dirname(__FILE__) . '/funciones/reportes.php');
$class_report=new class_report();
//require(dirname(__FILE__) . '/fpdf.php'); 
require(dirname(__FILE__) . '/sector.php');


class PDF extends FPDF{
    var $legends;
    var $wLegend;
    var $sum;
    var $NbVal;
	protected $B = 0;
	protected $I = 0;
	protected $U = 0;
	protected $HREF = '';
/*	function Header(){
		// Logo
		$this->Image('header.png',10,8,280);
		// Arial bold 15
		$this->SetFont('Arial','B',15);
		// Movernos a la derecha
		$this->Cell(80);
		// Título
		$this->Cell(30,10,'Title',1,0,'C');
		// Salto de línea
		$this->Ln(20);
	}*/
	// Cargar los datos
	function LoadData($file){
		// Leer las líneas del fichero
		$lines = file($file);
		$data = array();
		foreach($lines as $line)
			$data[] = explode(';',trim($line));
			//$aa = explode(';',trim($line));
			//print_r($aa);
			//exit;
		return $data;
	}

	// Tabla simple
	function BasicTable($header, $data){
		// Cabecera
		foreach($header as $col)
			$this->Cell(22,7,$col,1);
		$this->Ln();
		// Datos
		foreach($data as $row)	{
			foreach($row as $col)
				$this->Cell(22,6,$col,1);
			$this->Ln();
		}
	}

	// Una tabla más completa
	function ImprovedTable($header, $data){
		// Anchuras de las columnas
		$w = array(20, 20, 20, 12, 20, 18, 12, 20);
		// Cabeceras
		for($i=0;$i<count($header);$i++)
			$this->Cell($w[$i],7,$header[$i],1,0,'C');
		$this->Ln();
		// Datos
		foreach($data as $row){
			$this->Cell($w[0],6,$row[0],'LR');
			$this->Cell($w[1],6,$row[1],'LR');
			$this->Cell($w[2],6,$row[2],'LR');
			//$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R');
			$this->Cell($w[3],6,$row[3],'LR');
			//$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R');
			$this->Cell($w[4],6,$row[4],'LR');
			$this->Ln();
		}
		// Línea de cierre
		$this->Cell(array_sum($w),0,'','T');
	}

	// Tabla coloreada
	function FancyTable($header1, $header2, $data){
		// Colores, ancho de línea y fuente en negrita
		$this->SetFillColor(150,200,200); //fondo
		$this->SetTextColor(0,0,0);   //texto
		$this->SetDrawColor(0,0,0);    //bordes
		$this->SetLineWidth(.3);
		$this->SetFont('','B',7);
		//cabecera1
		$ac = array();
		for($i=0;$i<count($header1);$i++){
			$ac = explode('|',$header1[$i]);
			$this->Cell($ac[0],5,$ac[1],1,0,'C',true);
		}
		$this->Ln();
		// Cabecera2
		$w = array(); //el archo de la cabecera2 define el ancho de la data
		$ac2 = array();
		for($i=0;$i<count($header2);$i++){
			$ac2 = explode('|',$header2[$i]);
			$this->Cell($ac2[0],5,$ac2[1],1,0,'C',true);
			$w[]=$ac2[0]; //agrego los anchos en el array
		}
		$this->Ln();
		
		// Restauración de colores y fuentes
		$this->SetDrawColor(255,255,255);
		$this->SetFillColor(224,235,255);
		$this->SetTextColor(0);
		$this->SetFont('Arial','',7);
		// Datos
		$fill = false;
		foreach($data as $row){
			$this->Cell($w[0],5,$row[0],'LR',0,'L',$fill);
			$this->Cell($w[1],5,$row[1],'LR',0,'L',$fill);
			$this->Cell($w[2],5,$row[2],'LR',0,'L',$fill);
			$this->Cell($w[3],5,$row[3],'LR',0,'L',$fill);
			$this->Cell($w[4],5,$row[4],'LR',0,'L',$fill);
			$this->Cell($w[5],5,$row[5],'LR',0,'L',$fill);
			$this->Cell($w[6],5,$row[6],'LR',0,'L',$fill);
			$this->Cell($w[7],5,$row[7],'LR',0,'L',$fill);
			$this->Cell($w[8],5,$row[8],'LR',0,'L',$fill);
			$this->Cell($w[9],5,$row[9],'LR',0,'L',$fill);
			$this->Cell($w[10],5,$row[10],'LR',0,'L',$fill);
			$this->Cell($w[11],5,$row[11],'LR',0,'L',$fill);
			$this->Cell($w[12],5,$row[12],'LR',0,'L',$fill);
			$this->Ln();
			$fill = !$fill;
		}
		// Línea de cierre
		$this->Cell(array_sum($w),0,'','T');
	}

	
	function SetCol($col){
		// Establecer la posición de una columna dada
		$this->col = $col;
		$x = 10+$col*65;
		$this->SetLeftMargin($x);
		$this->SetX($x);
	}

	function WriteHTML($html){
		// Intérprete de HTML
		$html = str_replace("\n",' ',$html);
		$a = preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
		foreach($a as $i=>$e){
			if($i%2==0){
				// Text
				if($this->HREF)
					$this->PutLink($this->HREF,$e);
				else
					$this->Write(5,$e);
			}else{
				// Etiqueta
				if($e[0]=='/')
					$this->CloseTag(strtoupper(substr($e,1)));
				else{
					// Extraer atributos
					$a2 = explode(' ',$e);
					$tag = strtoupper(array_shift($a2));
					$attr = array();
					foreach($a2 as $v){
						if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
							$attr[strtoupper($a3[1])] = $a3[2];
					}
					$this->OpenTag($tag,$attr);
				}
			}
		}
	}
	
	function OpenTag($tag, $attr){
		// Etiqueta de apertura
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,true);
		if($tag=='A')
			$this->HREF = $attr['HREF'];
		if($tag=='BR')
			$this->Ln(5);
	}
	
	function CloseTag($tag){
		// Etiqueta de cierre
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,false);
		if($tag=='A')
			$this->HREF = '';
	}

	function SetStyle($tag, $enable){
		// Modificar estilo y escoger la fuente correspondiente
		$this->$tag += ($enable ? 1 : -1);
		$style = '';
		foreach(array('B', 'I', 'U') as $s){
			if($this->$s>0)
				$style .= $s;
		}
		$this->SetFont('',$style);
	}

	function PutLink($URL, $txt){
		// Escribir un hiper-enlace
		$this->SetTextColor(0,0,255);
		$this->SetStyle('U',true);
		$this->Write(5,$txt,$URL);
		$this->SetStyle('U',false);
		$this->SetTextColor(0);
	}
	
	//graficos
	function ColumnChart($w, $h, $data2, $format, $color=null, $maxVal=0, $nbDiv=4){
        // RGB for color 0
        $colors[0][0] = 155;
        $colors[0][1] = 75;
        $colors[0][2] = 155;

        // RGB for color 1
        $colors[1][0] = 0;
        $colors[1][1] = 155;
        $colors[1][2] = 0;

        // RGB for color 2
        $colors[2][0] = 75;
        $colors[2][1] = 155;
        $colors[2][2] = 255;

        // RGB for color 3
        $colors[3][0] = 75;
        $colors[3][1] = 0;
        $colors[3][2] = 155;

        $this->SetFont('Courier', '', 10);
        $this->SetLegends($data2,$format);
		
		

        // Starting corner (current page position where the chart has been inserted)
        $XPage = $this->GetX();
        $YPage = $this->GetY();
        $margin = 2; 

        // Y position of the chart
        $YDiag = $YPage + $margin;

        // chart HEIGHT
        $hDiag = floor($h - $margin * 2);

        // X position of the chart
        $XDiag = $XPage + $margin;

        // chart LENGHT
        $lDiag = floor($w - $margin * 3 - $this->wLegend);

        if($color == null)
            $color=array(155,155,155);
        if ($maxVal == 0) {
            foreach($data2 as $val){
                if(max($val) > $maxVal){
                    $maxVal = max($val);
                }
            }
        }

        // define the distance between the visual reference lines (the lines which cross the chart's internal area and serve as visual reference for the column's heights)
        $valIndRepere = ceil($maxVal / $nbDiv);

        // adjust the maximum value to be plotted (recalculate through the newly calculated distance between the visual reference lines)
        $maxVal = $valIndRepere * $nbDiv;

        // define the distance between the visual reference lines (in milimeters)
        $hRepere = floor($hDiag / $nbDiv);

        // adjust the chart HEIGHT
        $hDiag = $hRepere * $nbDiv;

        // determine the height unit (milimiters/data unit)
        $unit = $hDiag / $maxVal;

        // determine the bar's thickness
        $lBar = floor($lDiag / ($this->NbVal + 1));
        $lDiag = $lBar * ($this->NbVal + 1);
        $eColumn = floor($lBar * 80 / 100);
		
        // draw the chart border
        $this->SetLineWidth(0.2);
        $this->Rect($XDiag, $YDiag, $lDiag, $hDiag);

        $this->SetFont('Courier', '', 10);
        $this->SetFillColor($color[0],$color[1],$color[2]);
        $i=0;
		
        foreach($data2 as $val){
            //Column
            $yval = $YDiag + $hDiag;
            $xval = $XDiag + ($i + 1) * $lBar - $eColumn/2;
            $lval = floor($eColumn/(count($val)));
            $j=0;
			
            foreach($val as $v){
                $hval = (int)($v * $unit);
                $this->SetFillColor($colors[$j][0], $colors[$j][1], $colors[$j][2]);
                $this->Rect($xval+($lval*$j), $yval, $lval, -$hval, 'DF');
                $j++;
            }
            //Legend
            $this->SetXY($xval, $yval + $margin);
			
            //$this->Cell($lval, 5, $this->legends[$i],0,0,'C');
			//$this->Cell($lval, 5, $xval,0,0,'C');
			$this->Cell($lval, 5, 1,0,0,'C');
			
			
            $i++;
        }

        //Scales
        for ($i = 0; $i <= $nbDiv; $i++){
            $ypos = $YDiag + $hRepere * $i;
            $this->Line($XDiag, $ypos, $XDiag + $lDiag, $ypos);
            $val = ($nbDiv - $i) * $valIndRepere;
            $ypos = $YDiag + $hRepere * $i;
            $xpos = $XDiag - $margin - $this->GetStringWidth($val);
            $this->Text($xpos, $ypos, $val);
        }
    }

	function SetLegends($data2, $format){
        $this->legends=array();
        $this->wLegend=0;
        $this->NbVal=count($data2);
    }
	
}
//declaracion de la clase:
//$pdf = new PDF(); //por default;
$pdf = new PDF('L','mm','A4');  //para horizontal

// Títulos cabecera1
$header1 = array('8|_ ', '38|Empresa', '32|Cartera', '154|Credito', '40|_');
// Títulos cabecera2
$header2 = array('8|Pais', '8|Tipo', '30|Nombre', '18|Nombre', '14|Cesion', '15|Tipo', '26|Cuenta/Docto', '40|Producto', '15|Importe', '12|Dias Mora', '23|Calif', '23|Judicial', '40|Observacion');

// Carga de datos

//obtener datos de la bd
$ddd = array();
$aaa = array();
$data = array();
$codcliente=$_REQUEST["id"];
$tablacompleta=$class_report->genrepptd($codcliente);
if($class_report->tipdoc==1) $tipdoc = "DNI"; else $tipdoc = "OTROS";
while($fila=mysql_fetch_assoc($tablacompleta)){
	$data[] = explode(';',trim($fila["col"]));
}
/*
$ddd[]="PERU";
$ddd[]= "FIN";
$ddd[]= "BCP";
$ddd[]= "BCP-z";
$ddd[]= "PROSOL";
$ddd[]= "235";
$ddd[]= "023-4334";
$ddd[]= "2500";
$aaa[] = $ddd;
$aaa[] = $ddd;
$aaa[] = $ddd;
$aaa[] = $ddd;
$data[]=$aaa;
*/
$data2[0] = array(200, 190, 90);
$data2[1] = array(250, 230, 110);
$data2[2] = array(220, 280, 100);



$html = '<u>NOTA</u><br> La información en el presente reporte, corresponde a aquella proporcionada por su acreedor en virtud <br>
al contrato celebrado entre PROSOL y el acreedor. NO es publica, no se vende, no se comercializa ni se <br>
entrega al (a los) acreedor (es) que tenga(n) contrato vigente con PROSOL. De existir una diferencia y/o <br>
no estar conforme con los saldos, agradeceremos escribirnos a: clientes@prosol.com.pe o atravez de <br>
nuestros dominios:';

/*
$html = 'Ahora puede imprimir fácilmente texto mezclando diferentes estilos: <b>negrita</b>, <i>itálica</i>,
<u>subrayado</u>, o ¡ <b><i><u>todos a la vez</u></i></b>!<br><br>También puede incluir enlaces en el
texto, como <a href="http://www.fpdf.org">www.fpdf.org</a>, o en una imagen: pulse en el logotipo.';
*/



$pdf->AddPage();
//insertando imagen
$pdf->Image('img/header.png',10,8,280);
//dejamos un espacio
$pdf->Ln(40);
//insertamos datos del cliente
$pdf->SetFont('Arial','B',9);
$pdf->Cell(40,10,'NOMBRE / RAZON SOCIAL           :'.$class_report->nombrecli);
$pdf->Ln(5);
//$pdf->Cell(40,10,'TIPO DOC.                                       :'.$tipdoc);
//$pdf->Ln(5);
//$pdf->Cell(40,10,'NRO DOC.                                       :'.$class_report->numdoc);
//$pdf->Ln(5);
$pdf->Cell(40,10,'Fecha.                                              :'.date("d/m/Y"));
$pdf->Ln(5);
$pdf->Cell(40,10,'TOTAL DEUDA (SOLES).               :'.$class_report->sumacapital);

$pdf->Ln(5);
// Movernos a la derecha 
$pdf->Cell(120);
$pdf->Cell(30,10,'REPORTE DE DEUDAS',0,0,'C');
$pdf->Cell(65);

$pdf->SetFont('Arial','B',15);
$pdf->SetDrawColor(255,255,255);
$pdf->SetFillColor(0,0,64);
$pdf->SetTextColor(250,190,7);
$pdf->Cell(60,10,'www.pagatudeuda.com',1,0,'C',true);
$pdf->Ln(10);
//$this->Ln();
//$pdf->BasicTable($header,$data);
//$pdf->AddPage();
//$pdf->ImprovedTable($header,$data);
//$pdf->AddPage();
$pdf->FancyTable($header1,$header2,$data);

//grafico
$pdf->Ln(10);
$valX = $pdf->GetX();
$valY = $pdf->GetY();
$pdf->SetFont('Arial', '', 7);
$pdf->WriteHTML($html);
$pdf->SetLeftMargin(170);
$pdf->ColumnChart(100, 50, $data2, null, array(255,175,100));
$pdf->Output();
?>
