<?php
include(dirname(__FILE__) . '/funciones/reportes.php');
$class_report=new class_report();
//require(dirname(__FILE__) . '/fpdf.php'); 
require(dirname(__FILE__) . '/sector.php');


class PDF extends FPDF{
    var $legends;
    var $wLegend;
    var $sum;
    var $NbVal;
	var $angle=0;
	protected $B = 0;
	protected $I = 0;
	protected $U = 0;
	protected $HREF = '';
	
	//cabecera
	function Header(){
		$this->SetFont('Arial','B',50);
		$this->SetTextColor(255,192,203);
		$this->RotatedText(20,250,'D o c u m e n t o    d e m o',45);
		// Logo
		$this->Image('img/header.png',5,5,200);
		/*
		// Arial bold 15
		$this->SetFont('Arial','B',15);
		// Movernos a la derecha
		$this->Cell(80);
		// Título
		$this->Cell(30,10,'Title',1,0,'C');
		// Salto de línea
		$this->Ln(20); */
	}
	// Pie de página
	function Footer(){
		// Posición: a 1,5 cm del final
		$this->SetY(-20);
		// Arial italic 8
		$this->SetFont('Arial','I',8);
		// Número de página
		$this->Multicell(800,4, utf8_decode("NOTA: La información proporcionada por su acreedor en virtud al contrato celebrado entre 
		PROSOL y el acreedor. NO es publica, no se vende, no se comercializa, no se vende  ni se 
		entrega al (a los) acreedor (es) que tenga(n) contrato vigente con PROSOL. De existir una 
		diferencia y/o no estar conforme, escribirnos desde:"));
		$this->SetXY(125,-20);
		$this->SetFont('Arial','B',18);
		$this->SetDrawColor(255,255,255);
		$this->SetFillColor(0,0,130);
		$this->SetTextColor(250,200,70);
		$this->Cell(80,10,'www.pagatudeuda.com',1,0,'C',true);
		$this->SetFont('Arial','I',7);
		//$this->Cell(0,10,'Page '.$this->PageNo().'/{nb}',0,0,'C');
	}
	
	function RotatedText($x, $y, $txt, $angle){
		//Text rotated around its origin
		$this->Rotate($angle,$x,$y);
		$this->Text($x,$y,$txt);
		$this->Rotate(0);
	}
	
	function Rotate($angle,$x=-1,$y=-1){
		if($x==-1)
			$x=$this->x;
		if($y==-1)
			$y=$this->y;
		if($this->angle!=0)
			$this->_out('Q');
		$this->angle=$angle;
		if($angle!=0){
			$angle*=M_PI/180;
			$c=cos($angle);
			$s=sin($angle);
			$cx=$x*$this->k;
			$cy=($this->h-$y)*$this->k;
			$this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
		}
	}

	function _endpage(){
		if($this->angle!=0){
			$this->angle=0;
			$this->_out('Q');
		}
		parent::_endpage();
	}
	
	function LoadData($file){
		// Leer las líneas del fichero
		$lines = file($file);
		$data = array();
		foreach($lines as $line)
			$data[] = explode(';',trim($line));
			//$aa = explode(';',trim($line));
			//print_r($aa);
			//exit;
		return $data;
	}
	// Tabla simple
	function BasicTable($header, $data){
		// Cabecera
		foreach($header as $col)
			$this->Cell(22,7,$col,1);
		$this->Ln();
		// Datos
		foreach($data as $row)	{
			foreach($row as $col)
				$this->Cell(22,6,$col,1);
			$this->Ln();
		}
	}
	// Una tabla más completa
	function ImprovedTable($header, $data){
		// Anchuras de las columnas
		$w = array(20, 20, 20, 12, 20, 18, 12, 20);
		// Cabeceras
		for($i=0;$i<count($header);$i++)
			$this->Cell($w[$i],7,$header[$i],1,0,'C');
		$this->Ln();
		// Datos
		foreach($data as $row){
			$this->Cell($w[0],6,$row[0],'LR');
			$this->Cell($w[1],6,$row[1],'LR');
			$this->Cell($w[2],6,$row[2],'LR');
			//$this->Cell($w[2],6,number_format($row[2]),'LR',0,'R');
			$this->Cell($w[3],6,$row[3],'LR');
			//$this->Cell($w[3],6,number_format($row[3]),'LR',0,'R');
			$this->Cell($w[4],6,$row[4],'LR');
			$this->Ln();
		}
		// Línea de cierre
		$this->Cell(array_sum($w),0,'','T');
	}

	function FancyTable($header1, $header2, $codcliente, $tablacompleta){
		// Colores, ancho de línea y fuente en negrita
		$this->SetFillColor(150,200,200); //fondo
		$this->SetTextColor(0,0,0);   //texto
		$this->SetDrawColor(0,0,0);    //bordes
		$this->SetLineWidth(.3);
		$this->SetFont('','B',6);
		//cabecera1
		$ac = array();
		for($i=0;$i<count($header1);$i++){
			$ac = explode('|',$header1[$i]);
			$this->Cell($ac[0],5,$ac[1],1,0,'C',true);
		}
		$this->Ln();
		// Cabecera2
		$w = array(); //el ancho de la cabecera2 define el ancho de la data
		$ac2 = array();
		for($i=0;$i<count($header2);$i++){
			$ac2 = explode('|',$header2[$i]);
			$this->Cell($ac2[0],5,$ac2[1],1,0,'C',true);
			$w[]=$ac2[0]; //agrego los anchos en el array
		}
		$this->Ln();
		
		// Restauración de colores y fuentes
		$this->SetDrawColor(255,255,255);
		$this->SetFillColor(224,235,255);
		$this->SetTextColor(0);
		$this->SetFont('Arial','',6);
		
		
		
		$nrofilas=mysql_num_rows($tablacompleta);
		//echo '<script> alert("'.trim($codcliente).'");</script>'; 
		if($nrofilas==0) $this->Cell(40,5,'NO HAY DATOS');
		else{
			while($fila=mysql_fetch_assoc($tablacompleta)){
				$idcartera=$fila["IdCartera"];
				$sqlResult=$class_report->genrepptd($codcliente,$idcartera);
				while ($detfila=mysql_fetch_array($sqlResult)) {
					$data[] = explode(';',trim($detfila["col"]));
					foreach($data as $row){
						for($col=0;$col<count($w);$col++) $this->Cell($w[$col],5,$row[$col],'LR',0,'L',$fill);
						$this->Ln();
						$fill = !$fill;
					}
				}
			}
			// Datos
			$fill = false;
			
			// Línea de cierre
			$this->Cell(array_sum($w),0,'','T');
		}
	}
	
	function SetCol($col){
		// Establecer la posición de una columna dada
		$this->col = $col;
		$x = 10+$col*65;
		$this->SetLeftMargin($x);
		$this->SetX($x);
	}

	function WriteHTML($html){
		// Intérprete de HTML
		$html = str_replace("\n",' ',$html);
		$a = preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);
		foreach($a as $i=>$e){
			if($i%2==0){
				// Text
				if($this->HREF)
					$this->PutLink($this->HREF,$e);
				else
					$this->Write(5,$e);
			}else{
				// Etiqueta
				if($e[0]=='/')
					$this->CloseTag(strtoupper(substr($e,1)));
				else{
					// Extraer atributos
					$a2 = explode(' ',$e);
					$tag = strtoupper(array_shift($a2));
					$attr = array();
					foreach($a2 as $v){
						if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
							$attr[strtoupper($a3[1])] = $a3[2];
					}
					$this->OpenTag($tag,$attr);
				}
			}
		}
	}
	
	function OpenTag($tag, $attr){
		// Etiqueta de apertura
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,true);
		if($tag=='A')
			$this->HREF = $attr['HREF'];
		if($tag=='BR')
			$this->Ln(5);
	}
	
	function CloseTag($tag){
		// Etiqueta de cierre
		if($tag=='B' || $tag=='I' || $tag=='U')
			$this->SetStyle($tag,false);
		if($tag=='A')
			$this->HREF = '';
	}

	function SetStyle($tag, $enable){
		// Modificar estilo y escoger la fuente correspondiente
		$this->$tag += ($enable ? 1 : -1);
		$style = '';
		foreach(array('B', 'I', 'U') as $s){
			if($this->$s>0)
				$style .= $s;
		}
		$this->SetFont('',$style);
	}

	function PutLink($URL, $txt){
		// Escribir un hiper-enlace
		$this->SetTextColor(0,0,255);
		$this->SetStyle('U',true);
		$this->Write(5,$txt,$URL);
		$this->SetStyle('U',false);
		$this->SetTextColor(0);
	}
	//graficos
	function ColumnChart($w, $h, $data2, $format, $color=null, $maxVal=0, $nbDiv=12){
        // RGB for color 0
        $colors[0][0] = 155;
        $colors[0][1] = 75;
        $colors[0][2] = 155;

        // RGB for color 1
        $colors[1][0] = 0;
        $colors[1][1] = 155;
        $colors[1][2] = 0;

        // RGB for color 2
        $colors[2][0] = 75;
        $colors[2][1] = 155;
        $colors[2][2] = 255;

        // RGB for color 3
        $colors[3][0] = 75;
        $colors[3][1] = 0;
        $colors[3][2] = 155;

        $this->SetFont('Courier', '', 10);
        $this->SetLegends($data2,$format);
		// Starting corner (current page position where the chart has been inserted)
        $XPage = $this->GetX();
        $YPage = $this->GetY();
        $margin = 2; 
        // Posición Y del gráfico
        $YDiag = $YPage + $margin;
		
        // Gráfico ALTURA
        $hDiag = floor($h - $margin * 2);
        // posición X del gráfico
        $XDiag = $XPage + $margin;
        // Gráfico LARGO
        $lDiag = floor($w - $margin * 3 - $this->wLegend);

        if($color == null)
            $color=array(155,155,155);
        if ($maxVal == 0){
			
            foreach($data2 as $val){
                if(max($val) > $maxVal){
                    $maxVal = max($val);
                }
            }
			
        }
        // Definir la distancia entre las líneas de referencia visuales (las líneas que cruzan el área interna del gráfico y servir como referencia visual para las alturas de la columna)
        $valIndRepere = ceil($maxVal / $nbDiv);

        // Ajustar el valor máximo a trazar (recalcular a través de la nueva distancia calculada entre las líneas de referencia visuales)
        $maxVal = $valIndRepere * $nbDiv;
			
        // Definir la distancia entre las líneas de referencia visuales (en milímetros)
        $hRepere = floor($hDiag / $nbDiv);

        // Ajustar la ALTURA del gráfico
        $hDiag = $hRepere * $nbDiv;

        // Determinar la unidad de altura (milimetros / unidad de datos)
        $unit = $hDiag / $maxVal;
			
        // determine the bar's thickness
        $lBar = floor($lDiag / ($this->NbVal + 1));
        $lDiag = $lBar * ($this->NbVal + 1);
        $eColumn = floor($lBar * 80 / 100);

        // draw the chart border
        $this->SetLineWidth(0.2);
        $this->Rect($XDiag, $YDiag, $lDiag, $hDiag);

        $this->SetFont('Courier', '', 10);
        $this->SetFillColor($color[0],$color[1],$color[2]);
        $i=0;

		//print_r($valIndRepere);
		//exit;
		
        foreach($data2 as $val){
            //Column
            $yval = $YDiag + $hDiag;
            $xval = $XDiag + ($i + 1) * $lBar - $eColumn/2;
            $lval = floor($eColumn/(count($val)));
            $j=0;

            foreach($val as $v){
                $hval = (int)($v * $unit);
                $this->SetFillColor($colors[$j][0], $colors[$j][1], $colors[$j][2]);
                $this->Rect($xval+($lval*$j), $yval, $lval-1, -$hval, 'DF');
                $j++;
            }
            //Legend
            $this->SetXY($xval, $yval + $margin);
            $this->Cell($lval, 5, $this->legends[$i],0,0,'C');
			//$this->Cell($lval, 5, $xval,0,0,'C');
			//$this->Cell($lval, 5, 1,0,0,'C');
            $i++;
        }

        //Scales
        for ($i = 0; $i <= $nbDiv; $i++){
            $ypos = $YDiag + $hRepere * $i;
            $this->Line($XDiag, $ypos, $XDiag + $lDiag, $ypos);
            $val = ($nbDiv - $i) * $valIndRepere;
            $ypos = $YDiag + $hRepere * $i;
            $xpos = $XDiag - $margin - $this->GetStringWidth($val);
            $this->Text($xpos, $ypos, $val);
        }
    }

	function SetLegends($data2, $format){
        $this->legends=array();
        $this->wLegend=0;
        $this->NbVal=count($data2);
    }
	
}
//declaracion de la clase:
$pdf = new PDF(); //por default vertical;
//$pdf = new PDF('L','mm','A4');  //para horizontal
$pdf->SetMargins(5, 5, 0);
//explicacion: Cell(ancho, Alto, texto, borde, salto de linea, alineacion de texto)
//$pdf->SetAutoPageBreak(true, 20);
//$pdf->AliasNbPages();

$html = utf8_decode('<u>NOTA</u><br> La información en el presente reporte, corresponde a aquella proporcionada por su acreedor en virtud 
al contrato celebrado entre PROSOL y el acreedor. NO es publica, no se vende, no se comercializa ni se 
entrega al (a los) acreedor (es) que tenga(n) contrato vigente con PROSOL. De existir una diferencia y/o 
no estar conforme con los saldos, agradeceremos escribirnos a: clientes@prosol.com.pe o atravez de 
nuestros dominios:');

$pdf->AddPage();
//dejamos un espacio
$pdf->Ln(32);
//obtener datos de la bd
$data = array();
$codcliente=$_REQUEST["id"];
$tablacompleta=$class_report->clientesxacreedor($codcliente);
//insertamos datos del cliente

$pdf->SetFont('Arial','B',7);
$pdf->Cell(40,5,'NOMBRE / RAZON SOCIAL           :'.$class_report->nombrecli);
$pdf->Ln(5);
$pdf->Cell(40,5,'Fecha.                                              :'.date("d/m/Y"));
$pdf->Ln(5);
$pdf->Cell(40,5,'TOTAL DEUDA (SOLES).               :'.$class_report->sumacapital);
$pdf->Ln(5);
//$valX = $pdf->GetX();
//$valY = $pdf->GetY();
//tabla
// Colores, ancho de línea y fuente en negrita
$pdf->SetFillColor(150,200,200); //fondo
$pdf->SetTextColor(0,0,0);   //texto
$pdf->SetDrawColor(0,0,0);    //bordes
$pdf->SetLineWidth(.3);
$pdf->SetFont('','B',6);
//cabecera
// Títulos cabecera1
$header1 = array('32|Cartera', '129|Credito', '30|_');
// Títulos cabecera2
$header2 = array('10|Tipo', '26|Cuenta/Docto', '30|Producto', '15|Importe', '8|D. Mora', '20|Calif', '20|Judicial', '30|Observacion');


$y = $pdf->GetY();
$x = $pdf->GetX();
$width = 25;
$pdf->Multicell($width,5, utf8_decode("    ACREEDOR           
     NOMB-CARTERA"),1,'L','C',true);
$pdf->SetXY($x + $width, $y);
$x = $pdf->GetX();
$width = 135;
$pdf->Cell($width ,5,'CREDITO',1,0,'C',true);
$pdf->SetXY($x, $y + 5);
$pdf->Cell(10 ,5,'Tipo',1,0,'C',true);
$pdf->Cell(26 ,5,'Cuenta/Docto',1,0,'C',true);
$pdf->Cell(30 ,5,'Producto',1,0,'C',true);
$pdf->Cell(15 ,5,'Importe',1,0,'C',true);
$pdf->Cell(14 ,5,'Dias Mora',1,0,'C',true);
$pdf->Cell(20 ,5,'Calif',1,0,'C',true);
$pdf->Cell(20 ,5,'Judicial',1,0,'C',true);
$pdf->SetXY($x + $width, $y);
$width = 30;
$pdf->Cell($width,10, 'OBSERVACION',1,0,'C',true);
$pdf->Ln();
$w = array('25','10','26','30','15','14','20','20','30');

// Restauración de colores y fuentes
$pdf->SetDrawColor(255,255,255);
$pdf->SetFillColor(224,235,255);
$pdf->SetTextColor(0);
$pdf->SetFont('Arial','',6);

$nrofilas=mysql_num_rows($tablacompleta);
if($nrofilas==0) $pdf->Cell(40,5,'NO HAY DATOS');
else{
	while($fila=mysql_fetch_assoc($tablacompleta)){
		$idcartera=$fila["Acreedor"];
		$sqlResult=$class_report->genrepptd($codcliente,$idcartera);
		$pdf->SetFont('Arial','B',7);
		$pdf->Cell(20,5,'PROSOL');
		$pdf->Cell(40,5,$fila["total"]);
		$pdf->SetFont('Arial','',7);
		$pdf->Ln(4);
		$lingrid=0;
		while ($detfila=mysql_fetch_array($sqlResult)) {
			$data[] = explode(';',trim($detfila["col"]));
			foreach($data as $row){
				for($col=0;$col<count($w);$col++) $pdf->Cell($w[$col],5,$row[$col],'LR',0,'L',$fill);
				$pdf->Ln();
				$fill = !$fill;
			}
			//limpiar array
			unset($data);
			$data = array();
			$lingrid++;
		}
		$pdf->Ln(6);
	}
	// Datos
	$fill = false;
	
	// Línea de cierre
	$pdf->Cell(array_sum($w),0,'','T');
}


//grafico
$y = $pdf->GetY();
$x = $pdf->GetX();
$pdf->SetXY($x + 10, $y);

$colors2 = array();
// RGB for color 0
$colors2[0][0] = 155;
$colors2[0][1] = 75;
$colors2[0][2] = 155;

// RGB for color 1
$colors2[1][0] = 0;
$colors2[1][1] = 155;
$colors2[1][2] = 0;

// RGB for color 2
$colors2[2][0] = 75;
$colors2[2][1] = 155;
$colors2[2][2] = 255;

// RGB for color 3
$colors2[3][0] = 75;
$colors2[3][1] = 0;
$colors2[3][2] = 155;
// RGB for color 0
$colors2[4][0] = 155;
$colors2[4][1] = 75;
$colors2[4][2] = 155;

// RGB for color 1
$colors2[5][0] = 0;
$colors2[5][1] = 155;
$colors2[5][2] = 0;

// RGB for color 2
$colors2[6][0] = 75;
$colors2[6][1] = 155;
$colors2[6][2] = 255;

// RGB for color 3
$colors2[6][0] = 75;
$colors2[6][1] = 0;
$colors2[6][2] = 155;

$margin=2;  //margen
$h=70;     //altura
$nbDiv=8;   //numero de diviciones
// Gráfico ALTURA
$hDiag = floor($h - $margin * 2);
// Definir la distancia entre las líneas de referencia visuales (en milímetros)
$hRepere = floor($hDiag / $nbDiv);
// Ajustar la ALTURA del gráfico
$hDiag = $hRepere * $nbDiv;
		
$historico=$class_report->deudahistorica($codcliente);
$t=0;
$maxVal =0;
$value3=array();
while($fila2=mysql_fetch_assoc($historico)){
	if($fila2['Capital'] > $maxVal) $maxVal = $fila2['Capital'];
	$value3[] = $fila2['Capital'];
}

// Determinar la unidad de altura (milimetros / unidad de datos)
$unit = $hDiag / $maxVal;

 foreach($value3 as $v){
	$hval = (int)($v * $unit);
	$pdf->SetFillColor($colors2[$t][0], $colors2[$t][1], $colors2[$t][2]);
	$pdf->Rect(($t+3)*15,$y+80,8,-$hval,'DF');
	$t++;
}

$YDiag=$y+15;
$XDiag=$x-160;
$lDiag=140-2*3;

// Definir la distancia entre las líneas de referencia visuales (las líneas que cruzan el área interna del gráfico y servir como referencia visual para las alturas de la columna)
$valIndRepere = ceil($maxVal / $nbDiv);
 for ($i = 0; $i <= $nbDiv; $i++){
	$ypos = $YDiag + $hRepere * $i;
	$pdf->Line($XDiag, $ypos, $XDiag + $lDiag, $ypos);
	$val = ($nbDiv - $i) * $valIndRepere;
	$ypos = $YDiag + $hRepere * $i;
	$xpos = $XDiag - $margin - $pdf->GetStringWidth($val);
	$pdf->Text($xpos, $ypos, $val);
}


//foreach($data2 as $val){
//	if(max($val) > $maxVal) $maxVal = max($val);
//}
 
 
//grafico
/*
$data2[0] = array(15, 22, 33, 22);
//$data2[1] = array(11, 22, 33);
//$data2[2] = array(11, 22, 33);
$pdf->Ln(5);
//$pdf->SetXY(100,120);
//$pdf->ColumnChart(70, 40, $data2, null, array(255,175,100));
//$pdf->SetXY(20,120);
$y = $pdf->GetY();
$x = $pdf->GetX();
$pdf->SetXY($x + 80, $y);
$pdf->ColumnChart(100, 100, $data2, null, array(100,175,100));
$pdf->Ln(80);
$pdf->SetFont('Arial', '', 7);
//$pdf->WriteHTML($html);
*/
$pdf->Output();
?>
