#!/bin/bash
# -*- ENCODING: UTF-8 -*-
# Este script recibe 3 parametros
#1er parametro: Este es el tipo de envio que puede ser 1 para simple o 2 para masivo
#2do parametro: Es el codigo de plantilla
#3er parametro: que tendria que ser el codigo de usuario
#Ejemplo de como lanzarlo:
#bash efnsms.sh 2 10 100

# Ruta del archivo de registro de eventos
# Creamos la carpeta log para registros
# primero verificamos si existe
if [ ! -d "log" ]
then
	# si no existe la creamos
	mkdir log
fi
# cambiamos permiso y usuario propietario de la carpeta de registro
chmod 600 log
chown www-data:www-data log

# Validamos si los archivos log existen
# Primero log del sistema
if [ -f "log/$3_efnsms.log" ]; then
	echo "Archivo log sistema ya existe"
else
	# Creamos el archivo de registro de eventos del sistema
	touch log/$3_efnsms.log
fi
# Ahora log del usuario
if [ -f "log/$3_efnsms_envio.log" ]; then
	echo "Archivo log usuario ya existe"
else
	# Creamos los archivos de registro de eventos del usuario
	touch log/$3_efnsms_envio.log
fi
# establecemos los archivos log en variables
LOG="log/$3_efnsms.log"
LOGe="log/$3_efnsms_envio.log"
# Cambiamos permisos de los archivos log
chmod 600 $LOG
chmod 600 $LOGe
chown www-data:www-data $LOG
chown www-data:www-data $LOGe
# Definimos variable que tendra el contador de los registros para depurar
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: =================INICIO==================" >> $LOG
# Establecemos el usuario de la db
usu="root"
# Establecemos la contraseña de la db
cont="usu4r1o_mysq1_3ff1n3t"
# Vaciamos el archivo log del bash para evitar que se acumulen mas lineas y crezca mas el archivo
echo "" > $LOG
# Vaciamos el archivo log del usuario del bash para evitar que se acumulen mas lineas y crezca mas el archivo
echo "" > $LOGe
#Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 1 .........EVALUACION SIMPLE O MASIVA.............." >> $LOG
# Obtenemos fecha actual en formato unix con milisegundos
fech_s=`date +%s`
echo "`date '+%Y-%m-%d %H:%M:%S'`: 2 Fecha Actual en unix es $fech_s" >> $LOG
# Realizamos un if que evalua si el sms se trata de uno simple o de un masivo,
# si el sms es uno simple
if [[ $1 -eq "1" ]]
then
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........INICIO ENVIO........." >> $LOGe
	#Imprimimos el codigo de sms simple
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 3 El codigo de sms simple es $2" >> $LOG
	#Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 4 Modo envio Simple" >> $LOG
	# realizamos la consulta a la db para obtener todos parametros para enviar el sms simple
	prmsmp=($(mysql prosol -u $usu -p$cont --skip-column-names -e "SELECT w_smssmp.msg_cod,w_smssmp.msg_num,w_smssmp.msg_txt,w_smssmp.msg_cnl FROM w_smssmp ORDER BY w_smssmp.msg_cod DESC LIMIT 1"))
	#prmsmp=($(mysql efnmailer -u $usu -p$cont --skip-column-names -e "SELECT w_emlsmp.msg_dst, w_emlsmp.msg_asn, w_emlsmp.msg_tex, CASE WHEN ain_rut IS NULL THEN '' ELSE ain_rut END AS ain_rut,CASE WHEN aar_rut IS NULL THEN '' ELSE aar_rut END AS aar_rut FROM  efnmailer.w_emlsmp LEFT JOIN efnmailer.w_emladinc ON w_emladinc.ain_cod = w_emlsmp.ain_cod LEFT JOIN efnmailer.w_emladjar ON w_emladjar.aar_cod = w_emlsmp.aar_cod WHERE w_emlsmp.msg_cod = $2 AND aut_cusu = $3 LIMIT 1"))
	# Activar para depurar
	#echo ${prmcon[0]}
	#echo ${prmcon[1]}
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 5 Primer parametro para envio simple ${prmsmp[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 6 Segundo parametro para envio simple ${prmsmp[1]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 7 Tercer parametro para envio simple ${prmsmp[2]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 8 Cuarto parametro para envio simple ${prmsmp[3]}" >> $LOG

	# realizamos la consulta a la db para obtener todos parametros del equipo que va a enviar el sms
	prmsmp2=($(mysql prosol -u $usu -p$cont --skip-column-names -e "SELECT w_smseq.eq_wusu,w_smseq.eq_wcnt,w_smseq.eq_ip,w_smseq.eq_ausu,w_smseq.eq_acnt,w_smseq.eq_vapi FROM w_smseq WHERE w_smseq.eq_cod=1"))
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 9 Primer parametro para equipo envio ${prmsmp2[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 10 Segundo parametro para equipo envio ${prmsmp2[1]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 11 Tercer parametro para equipo envio ${prmsmp2[2]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 12 Cuarto parametro para equipo envio ${prmsmp2[3]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 13 Quinto parametro para equipo envio ${prmsmp2[4]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 14 Sexto parametro para equipo envio ${prmsmp2[5]}" >> $LOG
	
	#cmd=$(smtp-cli --verbose --host "${prmcnt[3]}" --port "${prmcnt[4]}" --user "${prmcnt[0]}" --pass "${prmcnt[1]}" --from "${prmcnt[2]}<${prmcnt[0]}>" --to "<${prmsmp[0]}>" --subject "${prmsmp[1]}" --body-html "${prmsmp[2]}" $adj $inc | grep "235")
	cmd=$(wget "http://${prmsmp2[0]}:${prmsmp2[1]}@${prmsmp2[2]}/cgi-bin/exec?cmd=api_queue_sms&username=${prmsmp2[3]}&password=${prmsmp2[4]}&content=${prmsmp[2]}&destination=${prmsmp[1]}&api_version=${prmsmp2[5]}" -qO-)
	# Activar para depurar
	#echo "wget http://'${prmsmp2[0]}':'${prmsmp2[1]}'@'${prmsmp2[2]}'/cgi-bin/exec?cmd=api_queue_sms&username='${prmsmp2[3]}'&password='${prmsmp2[4]}'&content='${prmsmp[2]}'&destination='${prmsmp[1]}'&api_version='${prmsmp2[5]}' -qO-"
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 15 | destinatario: <${prmsmp[1]}> | mensaje: ${prmsmp[2]} | estado: $cmd" >> $LOGe
	echo "`date '+%Y-%m-%d %H:%M:%S'`: =================FIN==================" >> $LOG
	# Fin envio
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........FIN ENVIO........." >> $LOGe
	exit
elif [[ $1 -eq "2" ]]
then
	#Imprimimos el codigo de parametro para sms masivo
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 17 El codigo de parametro es $2" >> $LOG
	#Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 18 Modo Masivo con cadencia" >> $LOG
	#Insertamos un registro en la tabla procesos para indicar a la plataforma que estamos iniciando un proceso de envio masivo
	#mysql efnmailer -u $usu -p$cont -se "insert into w_emlprs (prs_id,prs_est,prs_fech) values(123,1,${fech_s})"
	#actualizamos el registro de la tabla proceso para indicar a la plataforma que inicio el proceso
	mysql efnmailer -u $usu -p$cont -se "update w_emlprs set prs_est=1, prs_cenv=$2, prs_fech=$fech_s where aut_cusu like $3 and prs_cenv like $2"
	# Validamos si existe el archivo interruptor
	if [ -f "int/$3_intrp" ]; then
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 19 El archivo int/$3_intrp ya existe no hacemos nada" >> $LOG
	else
		# Creamos el archivo interruptor
		touch int/$3_intrp
		# cambiamos permiso a archivo interruptor
		chmod 777 int/$3_intrp
	fi
	# Modificamos el valor del archivo para indicar que tenemos un proceso iniciando
	echo 1 > int/$3_intrp
fi
#=====================#
#= CONSULTAS A LA DB =#
#=====================#
echo "`date '+%Y-%m-%d %H:%M:%S'`: 20 .........CONSULTAS A LA DB" >> $LOG
# consulta para obtener el tiempo aleatorio 1
tmp1=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.par_al1 from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 21 El primer tiempo de la db es: $tmp1" >> $LOG
# consulta para obtener el tiempo aleatorio 2
tmp2=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.par_al2 from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 22 El segundo tiempo de la db es: $tmp2" >> $LOG
# consulta para obtener verificar si esta activo la opccion aleatorio entre destinatarios
ades=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.par_alc from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 23 Activo aleatorio entre destinatarios: $ades" >> $LOG
# consulta para obtener codigo de categoria
ccat=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.cat_cod from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 24 El codigo de categoria es: $ccat" >> $LOG
# consulta para obtener codigo de plantilla
cplan=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.plan_cod from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 25 El codigo de plantilla es: $cplan" >> $LOG
# consulta para obtener codigo de cuenta de remitente para cruzar con tabla correos enviadores y ontener correo enviador
crem=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.cnts_cod from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 26 El codigo de correo remitente es: $crem" >> $LOG
# consulta para obtener el archivo de carga
arcarg=$(mysql efnmailer -u $usu -p$cont -se "select w_emlparam.par_csv from w_emlparam where w_emlparam.par_cod = "$2" limit 1")
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 27 El nombre del archivo de carga es $arcarg" >> $LOG
# Obtenemos los parametros del servidor para enviar las cuentas de correo, primero realizamos la consulta
prmcon=($(mysql efnmailer -u $usu -p$cont --skip-column-names -e "select w_emlcnf.cnf_coetau, w_emlcnf.cnf_coenau, w_emlcnf.cnf_coetenc, w_emlcnf.cnf_coesrv, w_emlcnf.cnf_coeprt, w_emlcnf.cnf_coecc from w_emlcnf limit 1"))
# Activar para depurar
#echo ${cntcor[0]}
#echo ${cntcor[1]}
echo "`date '+%Y-%m-%d %H:%M:%S'`: 28 Primer parametro para cuentas de envio ${prmcon[0]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 29 Segundo parametro para cuentas de envio ${prmcon[1]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 30 Tercer parametro para cuentas de envio ${prmcon[2]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 31 Cuarto parametro para cuentas de envio ${prmcon[3]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 32 Quinto parametro para cuentas de envio ${prmcon[4]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 33 Sexto parametro para cuentas de envio ${prmcon[5]}" >> $LOG
# Realizamos un if que valida si el parametro de con copia esta activo:
if [[ "${prmcon[5]}" != "" ]]
then
	cc="--cc ${prmcon[5]}"	
fi
# EVALUACIONES #
# Evaluamos el segundo tiempo aleatorio, de ser vacio dejamos en cero
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 34 Segundo tiempo establecido en $tmp2" >> $LOG
# VALIDACION PARA OBTENER PLANTILLAS
echo "`date '+%Y-%m-%d %H:%M:%S'`: 35 Aleatorio entre destinatarios esta en estado $ades" >> $LOG
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 36 Ingresamos en evaluacion para obtener plantillas aleatorias" >> $LOG
# Evaluamos si el codigo de plantilla es vacio
if [[ $((cplan)) -eq 0 ]]
then
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 37 Entrando en segmento plantillas aleatorias" >> $LOG
	# De ser asi, dejamos variable de codigo con cero
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 38 Codigo de plantilla establecido $cplan" >> $LOG
	# Declaramos separador de espacios en tabulacion
	IFS="$( echo -e '\t' )"
	# Declaramos contador
	t=0
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 39 Contador de array de plantillas inicia en $t" >> $LOG
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 40 Ingresamos a bucle para obtener array de plantillas" >> $LOG
	# Obtenemos los mensajes y asuntos y almacenamos en array para luego utilizarlos,
	# para lograr esto, realizamos un wile que recorra las consultas devueltas por la db
	while read -a row
	do
		# Activar para depurar
		#echo "`date '+%Y-%m-%d %H:%M:%S'`: 26-$((regbu1=regbu1+1)) la primera celda obtenida del blucle de array plantillas es ${row[0]}"
		#echo "`date '+%Y-%m-%d %H:%M:%S'`: 26-$((regbu1=regbu1+1)) la segunda celda obtenida del blucle de array plantillas es ${row[1]}"
		#echo "`date '+%Y-%m-%d %H:%M:%S'`: 26-$((regbu1=regbu1+1)) la tercera celda obtenida del blucle de array plantillas es ${row[2]}"
		# De ser asi, asignamos valor a array de asunto
		arrcora[$t]=$(echo "${row[0]}")
		# Asignamos valor a array de mensajes
		arrcorm[$t]=$(echo "${row[1]}")
		# Aumentamos contador en uno
		# Asignamos valor a array de adjuntos
		arrcorad[$t]=$(echo "${row[2]}")
		# Aumentamos contador en uno
		((t=t+1))
	done < <(echo "select w_emlplan.plan_asn, w_emlplan.plan_msg, w_emlplan.plan_cod from w_emlplan where w_emlplan.cat_cod = $ccat order by rand() limit 100" | mysql efnmailer -u $usu -p$cont --skip-column-names)
	# Regresamos a la variable separados de espacios a su normalidad
	unset IFS
	# Activar solo para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 41 El array de asuntos es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcora[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 42 El array de mensajes es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorm[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 43 El array de adjuntos es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorad[@]}" >> $LOG
# De lo contrario
else
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 44 Entrando en segmento plantilla definida" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 45 Codigo de plantilla es $cplan" >> $LOG
	#Obtenemos el mensaje establecido mediante consulta a la base de datos, primero
	# declaramos separador de espacios en tabulacion
	IFS="$( echo -e '\t' )"
	# Declaramos contador
	t=0
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 46 Contador de plantillas inciado en $t" >> $LOG
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 47 Ingresamos a bucle para obtener array de plantillas" >> $LOG
	# Obtenemos los mensajes y asuntos y almacenamos en array para luego utilizarlos,
	# para lograr esto, realizamos un wihe que recorra las consultas devueltas por la db
	while read -ra rowm
	do
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 48-$((regbu2=regbu2+1)) La primera celda obtenida del bucle de array de plantillas es ${rowm[0]}" >> $LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 48-$((regbu2=regbu2+1)) La segunda celda obtenida del bucle de array de plantillas es ${rowm[1]}" >> $LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 48-$((regbu2=regbu2+1)) La tercera celda obtenida del bucle de array de plantillas es ${rowm[1]}" >> $LOG
		# De ser asi, asignamos valor a array de asunto
		arrcora[$t]=$(echo "${rowm[0]}")
		# Asignamos valor a array de mensajes
		arrcorm[$t]=$(echo -en "${rowm[1]}")
		# Asignamos valor a array de adjuntos
		arrcorad[$t]=$(echo "${rowm[2]}")
		# Aumentamos contador en uno
		((t=t+1))
	done < <(echo "select w_emlplan.plan_asn, w_emlplan.plan_msg, w_emlplan.plan_cod from w_emlplan, w_emlparam where w_emlparam.plan_cod = w_emlplan.plan_cod and w_emlplan.plan_cod = "$cplan" limit 1" | mysql efnmailer -u $usu -p$cont --skip-column-names --default-character-set=utf8)
	# Regresamos a la variable separados de espacios a su normalidad
	unset IFS
	# 2 ejemplos de como reemplazar codigo html en variable
	#ert=`echo "${arrcorm[0]}" | sed 's|>n<|><|g'`
	#ert="$(sed 's|>n<|><|g' <<<${arrcorm[0]})"
	# Activar solo para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 49 El array de asuntos es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcora[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 50 El array de mensajes es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorm[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 51 El array id's de adjuntos es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ' ${arrcorad[@]} ' " >> $LOG
fi
# Contamos la cantidad de items que tiene el archivo de mensajes aleatorios y almacenamos en variable
NAME_M=arrcora
tmp_m="${NAME_M}[@]"
copy_m=( "${!tmp_m}" )
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 52 La cantidad de elementos en el array resultante es ${#copy_m[@]}" >> $LOG
# Almacenamos resultado de la cantidad de elementos del array a variable
nmenenv=`echo ${#copy_m[@]}`
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 53 La cantidad de elementos en el array de mensajes es $nmenenv" >> $LOG

# VALIDACIONES PARA OBTENER ARRAY DE ADJUNTOS
echo "`date '+%Y-%m-%d %H:%M:%S'`: 54 Segmento para obtener array de adjuntos" >> $LOG
# Declaramos contador
h=0
# Realizamos un bucle que recorra cada id de adjunto y cree un array segun el nombre
# del registro de cada array
echo "`date '+%Y-%m-%d %H:%M:%S'`: 55 Entrando a bucle de array adjuntos" >> $LOG
for v in "${arrcorad[@]}"
do
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 56-$((regbu3=regbu3+1)) El id de adjunto que estamos recorriendo es $v" >> $LOG
	# Establecemos el nombre 
	arrad=arrcoraad$v
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 56-$((regbu3=regbu3+1)) El nombre del array de adjuntos establecidos es $arrad" >> $LOG
	# Realizamos un bucle que ejecute una consutla de mysql con cada id de plantilla
	while read -a rowa
	do
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'` 56-$((regbu3=regbu3+1))-$((regbu4=regbu4+1)) recorriendo id de plantilla ${rowa[0]}" >> $LOG
		# Declaramos variable de inicio
		ini='--attach-inline '
		# Declaramos variable de espacios
		spc=' '
		# Establecemos el valor del array creado con el valor del indice, pero
		# creando la cadena de adjunto
		eval "$arrad[h]+='$ini'$(echo ../${rowa[0]})"'$spc'
#		eval $arrad[h]+="$(echo ${rowa[0]})"
	done < <(echo "select w_emladjar.aar_rut from w_emladjar,w_emlplan where w_emladjar.plan_cod = w_emlplan.plan_cod and w_emladjar.plan_cod = $v order by rand() limit 100" | mysql efnmailer -u $usu -p$cont --skip-column-names)
	# Aumentamos contador en uno
	((h=h+1))
done
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 57 El contenido del array de adjuntos es ${!arrad[0]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: 58 Entrando en segmento para obtener correos enviadores" >> $LOG

# VALIDACION PARA OBTENER CORREOS ENVIADORES

# Evaluamos si el parametro para obtener codigo de correo enviador esta en cero
if [[ $((crem)) -eq 0 ]]
then
	# De ser asi, entonces no se ha establecido una cuenta especifica para enviar por lo que asusimos que se desea modo aleatorio 
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 59 Cuenta de remitente no especificado, por lo tanto se asume aleatorio" >> $LOG
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 59 Obtenemos array de correos enviadores" >> $LOG
	# Obtenemos los correos y almacenamos en array para luego utilizarlos pero pasamos el parametro -t a mysql
	# para que el resutlado obtenido sea en forma de tabla
	cntcor=$(mysql efnmailer -u $usu -p$cont --skip-column-names -t -e "SELECT w_emlcnts.cnts_coeusu, w_emlcnts.cnts_coecnt, w_emlcnts.cnts_coeali, w_emldom.dom_nomb, w_emldom.dom_port FROM w_emlcnts INNER JOIN w_emldom ON w_emlcnts.dom_cod=w_emldom.dom_cod WHERE w_emlcnts.aut_cusu='$3' ORDER BY RAND() LIMIT 25;")
			# Antigua forma de recorrer todos los items del array y asignarlos a otro array
			# arrcor=($(for e in $cntcor ; do echo $e ; done))
			# echo ${arrcor[@]}
	# Activar para depurar
	# echo $cntcor
	# Declaramos contador 
	t=0
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 60 contador de registro incia en $t" >> $LOG
	# Declaramos el separador de espacios universal en linux para que interprete los espacios
	IFS=$'\n'
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 61 Incio bucle array correos enviadores" >> $LOG
	#realizamos un bucle para recorrer registros correos enviadores obtenidos de la db
	for e in $cntcor
	do
		#Activar para depurar
		#echo $t
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 63-$((regbu5=regbu5+1)) Valor actual del item es $e" >> $LOG
		# Realizamos un if que evalue si nos encontramos en el primer valor del contador que quiere
		# decir que estamos en el primer elemento del array y si no nos encontramos en la ultima
		# posicion del array que comienza con "+"
		if [[ $((t)) -gt 0 && $e != +* ]]
		then
			# Activar para depurar
			#echo $t
			# Establecemos cada valor que nos conbiene delimitados por "|", sin reemplazando salto
			# de lineas con nada y sin espacios al incio y final filtrado con el comando xargs
			arrcoru[$t-1]=$(echo $e | cut -d '|' -f2 | sed 's/\r//' | xargs)
			arrcorc[$t-1]=$(echo $e | cut -d '|' -f3 | sed 's/\r//' | xargs)
			arrcorl[$t-1]=$(echo $e | cut -d '|' -f4 | sed 's/\r//' | xargs)
			arrcors[$t-1]=$(echo $e | cut -d '|' -f5 | sed 's/\r//' | xargs)
			arrcorp[$t-1]=$(echo $e | cut -d '|' -f6 | sed 's/\r//' | xargs)
		fi
		# Aumentamos contador en uno
		((t=t+1))
	done

	echo "`date '+%Y-%m-%d %H:%M:%S'`: 64 Fin bucle array correos enviadores" >> $LOG
	# Activar solo para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 65 El usuario de los correos enviadores es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcoru[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 66 La contraseña de los correos enviadores es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorc[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 67 El alias de los correos enviadores es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorl[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 68 El servidor de los correos enviadores es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcors[@]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 69 El puerto del servidor de los correos enviadores es" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ${arrcorp[@]}" >> $LOG
	# Activar para depurar
	#echo "${arrcoru[@]}"
	#echo "${arrcorc[@]}"
	#echo "${arrcorl[@]}"
	#echo "${arrcors[@]}"
	#echo "${arrcorp[@]}"
	# Regresamos a la variable separados de espacios a su normalidad
	unset IFS
# De lo contrario
else
	#Obtenemos el correo establecido mediante consulta a la base de datos
	cntcor=$(mysql efnmailer -u $usu -p$cont --skip-column-names -t -e "SELECT w_emlcnts.cnts_coeusu, w_emlcnts.cnts_coecnt, w_emlcnts.cnts_coeali, w_emldom.dom_nomb, w_emldom.dom_port FROM w_emlparam, w_emlcnts,w_emldom WHERE w_emlparam.cnts_cod = w_emlcnts.cnts_cod AND w_emlcnts.dom_cod=w_emldom.dom_cod AND w_emlcnts.cnts_cod = "$crem" AND w_emlparam.aut_cusu = "$3" LIMIT 1")
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 70 El array resultante de la consulta para los correos enviadores es ${cntcor[@]}" >> $LOG
	# Declaramos contador 
	t=0
	# Declaramos el separador de espacios universal en linux para que interprete los espacios
	IFS=$'\n'
	# Activar para depurar
	for e in $cntcor
	do
		#Activar para depurar
		#echo $e
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 71-$((regbu5=regbu5+1)) Valor actual del item es $e" >> $LOG
		# Realizamos un if que evalue si nos encontramos en el primer valor del contador que quiere
		# decir que estamos en el primer elemento del array y si no nos encontramos en la ultima
		# posicion del array que comienza con "+"
		if [[ $((t)) -gt 0 && $e != +* ]]
		then
			# Activar para depurar
			#echo $t
			# Establecemos cada valor que nos conbiene delimitados por "|", sin reemplazando salto
			# de lineas con nada y sin espacios al incio y final filtrado con el comando xargs
			arrcoru[$t-1]=$(echo $e | cut -d '|' -f2 | sed 's/\r//' | xargs)
			arrcorc[$t-1]=$(echo $e | cut -d '|' -f3 | sed 's/\r//' | xargs)
			arrcorl[$t-1]=$(echo $e | cut -d '|' -f4 | sed 's/\r//' | xargs)
			arrcors[$t-1]=$(echo $e | cut -d '|' -f5 | sed 's/\r//' | xargs)
			arrcorp[$t-1]=$(echo $e | cut -d '|' -f6 | sed 's/\r//' | xargs)
		fi
		# Aumentamos contador en uno
		((t=t+1))
	done
#	arrcoru[0]=$( echo ${cntcor[0]} )
#	arrcorc[0]=$( echo ${cntcor[1]} )
#	arrcorl[0]=$( echo "${cntcor[2]}" )
#	arrcors[0]=$( echo ${cntcor[1]} )
#	arrcorp[0]=$( echo ${cntcor[1]} )
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 72 El usuario del correo enviador es" >> $LOG	
	echo "${arrcoru[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 73 La contraseña del correo enviador es" >> $LOG
	echo "${arrcorc[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 74 El alias del correo enviador es" >> $LOG
	echo "${arrcorl[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 75 El servidor del correo enviador es" >> $LOG
	echo "${arrcors[0]}" >> $LOG
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 76 El puerto del servidor correo enviador es" >> $LOG
	echo "${arrcorp[0]}" >> $LOG
fi
# Contamos la cantidad de items que tiene el array de correos enviadores y almacenamos en variable
NAME_C=arrcoru
tmp_c="${NAME_C}[@]"
copy_c=( "${!tmp_c}" )
# Almacenamos resultado de la cantidad de elementos del array a variable
ncorenv=`echo ${#copy_c[@]}`
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 77 Cantidad elementos en array resultante correos enviadores ${#copy_c[@]}" >> $LOG
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 78 cantidad elementos en variable resultante correos enviadores $ncorenv" >> $LOG
# Contamos la cantidad de lineas que tiene el archivo de carga
lin=$(awk '{d++}END{print d}' temporal/$arcarg)
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 79 Cantidad lineas en archivo cargaS $lin" >> $LOG
# Insertamos el registro en la tabla procesos diarios para indicar que se ha finalizado el proceso del dia
mysql efnmailer -u $usu -p$cont -se "insert into w_emlenv (env_cenv, env_fenv, env_ndes, aut_cusu) values ($2,$fech_s,$lin,$3)"
# Obtenemos fecha actual en formato unix con milisegundos
#fech_a=`date +%d%m%Y`
fech_a=`date +%s%3N`
#==========================
# INICIO METODO ALEATORIO 1
#==========================
echo "`date '+%Y-%m-%d %H:%M:%S'`: ........INICIO METODO ALEATORIO1" >> $LOG
# Declaramos array vacio que sera el array resultante final
resul=()
# Declaramos contador de registros 
x=1
echo "`date '+%Y-%m-%d %H:%M:%S'`: 80 Variable contador registros $x" >> $LOG
# Eliminamos la carpeta de procesamiento rand en caso exista
rm -rf "masivo/rand_$3_$fech_a_${arcarg%.*}"
# Creamos carpeta temporal para procesar el archivo pero sin la extension del archivo de carga
mkdir "masivo/rand_$3_$fech_a_${arcarg%.*}"
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 81 Carpeta aleatoria creada es masivo/rand_$3_$fech_a_${arcarg%.*}" >> $LOG
# Realizamos una copia del archivo a editar
cp -r temporal/$arcarg "masivo/rand_$3_$fech_a_${arcarg%.*}/$arcarg.rand"
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 82 archivo carga $arcarg copiado con nuevo nombre a masivo/rand_$3_$fech_a_${arcarg%.*}/$arcarg.rand" >> $LOG
# ingresamos a la carpeta creada
cd "masivo/rand_$3_$fech_a_${arcarg%.*}"
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 83 Ingresamos a carpeta creada, la nueva ruta en la que estamos es `pwd`" >> ../../$LOG
# Dividimos el archivo en fragmentos de 500 cada uno
split -a 4 -dl 500 $arcarg.rand rnd
# Eliminamos el archivo copiado
rm -rf $arcarg.rand
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 84 archivo carga dividido en fragmentos, eliminando archivo anteriormente copiado $arcarg.rand, ya no se usara" >> ../../$LOG
# contamos la cantidad de archivos que hay en la carpeta creada
cntfil=`echo $(ls -1 | wc -l)`
# Activar para depurar
echo "`date '+%Y-%m-%d %H:%M:%S'`: 85 cantidad archivos fragmentos creados en la carpeta: $cntfil" >> ../../$LOG
# Declaramos contador
j=0
# retrocedemos un directorio
cd ..
echo "`date '+%Y-%m-%d %H:%M:%S'`: 86 Regresamos a directorio anterior, la nueva ruta en la que estamos es `pwd`" >> ../$LOG
# Realizamos while que recorra todos los archivos contados
echo "`date '+%Y-%m-%d %H:%M:%S'`: 87 ENTRANDO BUCLE ALEATORIO" >> ../$LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........INICIO ENVIO........." >> ../$LOGe

while [ 0 -ne $cntfil ]
do
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: ........INICIA BLUCLE LINEAS" >> ../$LOG
	# Construimos el nombre del primer pedazo del archivo de carga, primero
	# rellenamos con cero el contador hasta el limite deseado
	nord=`echo $(printf "%04.0f" $j)`
	# Luego lo unimos al prefijo de pedazo de archivo
	parccar="rnd$nord"
	# Activar para depurar
	#echo "el fragmento de archivo es $parccar"
	# Contamos la cantidad de lineas que tiene el archivo de carga
	plin=$(awk '{x++}END{print x}' rand_$3_$fech_a_${arcarg%.*}/$parccar)
	# Activar para depurar
	echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu6=regbu6+1)) Cantidad de lineas del pedazo de carga seleccioado es $plin" >> ../$LOG
	# Establecemos el numero de registros del archivo en variable
	nreg=$plin
	# Declaramos un while que recorra hasta la cantidad de registros que existen
	# en el pedazo del archivo de carga
	while [ 0 -ne $nreg ]
	do
		# Leemos el archivo interruptor
		inte=$(head -1 ../int/$3_intrp | tail -1)
		# Activar para depurar
		#echo $inte
		# Realizamos un if que evalue el estado del interruptor para detener el bucle,
		# si esta activado
		if [[ $((inte)) -eq 3 ]]
		then
			# Modificamos el valor del archivo
			echo "" > ../int/$3_intrp
			#Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........ENVIO CANCELADO........." >> ../$LOG
			echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........FIN ENVIO........." >> ../$LOG
			echo "`date '+%Y-%m-%d %H:%M:%S'`: =================TERMINO==================" >> ../$LOG
			echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........ENVIO CANCELADO........." >> ../$LOGe
			#actualizamos el registro de la tabla proceso para indicar a la plataforma que finalizo el proceso
			mysql efnmailer -u $usu -p$cont -se "update w_emlprs set prs_est=3 where aut_cusu like $3 and prs_cenv like $2"
			# Eliminamos todos los correos en la cola
			postsuper -d ALL
			postsuper -d ALL deferred
			# terminamos el bash
			exit
		fi
		echo "`date '+%Y-%m-%d %H:%M:%S'`: .........INICIA BUCLE PEDAZO" >> ../$LOG
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) El contador de bucle del pedazo esta en: $nreg" >> ../$LOG
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) El numero de mensaje que estamos enviando y contador general de envio es el $x" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Entramos evaluacion aleatorios entre mensajes" >> ../$LOG
		# Evaluamos si se activo la opccion de aleatorio entre mensajes
		if [[ $((ades)) -eq 0 ]] 
		then
			# Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) No se activo aleatorio entre mensajes" >> ../$LOG
			#Seguimos la secuencia, pero recordar que siempre elimino la primera linea
			# y la segunda linea se convierte en la primera, por lo tanto, siempre tengo
			# que leer la primera linea, entonces el contador siempre sera uno
			nran=1
		# De lo contrario
		else
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Activo aleatorio entre mensajes" >> ../$LOG
			# si es asi, generamos un numero aleatorio segun los parametros limites
			nran=`echo $(((RANDOM % $nreg)+1))`
			# Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Numero aleatorio generado para mensaje es $nran" >> ../$LOG
		fi
		# Asignamos contenido de la linea extraida a la variable
#		resul[$x]=`echo $(head -${nran} rand_$fech_a_$arcarg/$parccar | tail -1) | sed 's/.$//'`
		# Activar para depurar
#		echo $(head -${nran} $arcarg".rand" | tail -1)
		# Leemos la linea que nos interesa
		reg=$(head -${nran} rand_$3_$fech_a_${arcarg%.*}/$parccar | tail -1)
		# Dividimos la linea en nombre y correo destinatario
		cor=$(echo $reg | cut -d ',' -f1 | sed 's/\r//')
		nom=$(echo $reg | cut -d ',' -f2 | sed 's/\r//')
		imp=$(echo $reg | cut -d ',' -f3 | sed 's/\r//')
		tlf=$(echo $reg | cut -d ',' -f4 | sed 's/\r//')
		drc=$(echo $reg | cut -d ',' -f5 | sed 's/\r//')
		add1=$(echo $reg | cut -d ',' -f6 | sed 's/\r//')
		add2=$(echo $reg | cut -d ',' -f7 | sed 's/\r//')
		add3=$(echo $reg | cut -d ',' -f8 | sed 's/\r//')
		add4=$(echo $reg | cut -d ',' -f9 | sed 's/\r//')
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Nombre y Correo destinatarios son" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: $cor" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: $nom" >> ../$LOG

		# Generamos numero aleatorio para obtener correo enviador
		cenvr=`echo $(((RANDOM % $ncorenv)))`
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Id random generado para correo enviador es $cenvr" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Correo enviador elegido es ${arrcoru[$cenvr]}" >> ../$LOG
		# Generamos numero aleatorio para obtener mensaje a enviar
		menvr=`echo $(((RANDOM % $nmenenv)))`
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Id random generado para mensaje $menvr" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Asunto y mensaje elegidos '${arrcora[$menvr]}' y '${arrcorm[$menvr]}'" >> ../$LOG
		# Activar para depurar, mando a un archivo separado para saber que estoy reemplazando
		echo $cor >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $nom >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $imp >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $tlf >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $drc >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $add1 >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $add2 >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $add3 >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		echo $add4 >> rand_$3_$fech_a_${arcarg%.*}/reemplazo.log
		# Activar para depurar
		#echo "${arrcorm[$menvr]}" | iconv -t utf-8
		# Sustituimos las variables de la plantilla por los valores deseados
		# Activar para depurar
		#echo "|" >> reemplazo.log
		asn=`echo "${arrcora[$menvr]}" | sed 's/((Titular))/'"$nom"'/'`
		# Activar para depurar
		#echo $asn >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg1=`echo "${arrcorm[$menvr]}" | sed 's/((Titular))/'"$nom"'/'`
		# Activar para depurar
		#echo $msg1 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg2=`echo "$msg1" | sed 's/((Direccion))/'"$drc"'/'`
		# Activar para depurar
		#echo $msg2 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg3=`echo "$msg2" | sed 's/((Importe))/'"$imp"'/'`
		# Activar para depurar
		#echo $msg3 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg4=`echo "$msg3" | sed 's/((Telefono))/'"$tlf"'/'`
		# Activar para depurar
		#echo $msg4 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg5=`echo "$msg4" | sed 's/((Add1))/'"$add1"'/'`
		# Activar para depurar
		#echo $msg5 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg6=`echo "$msg5" | sed 's/((Add2))/'"$add2"'/'`
		# Activar para depurar
		#echo $msg6 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg7=`echo "$msg6" | sed 's/((Add3))/'"$add3"'/'`
		# Activar para depurar
		#echo $msg7 >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		msg=`echo "$msg7" | sed 's/((Add4))/'"$add4"'/'`
		# Activar para depurar
		#echo $msg >> reemplazo.log
		# Activar para depurar
		#echo "|" >> reemplazo.log
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Mensaje y asunto con variables reemplazadas son:" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: $asn" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: $msg" >> ../$LOG
		# Establecemos el nombre del array seleccionado
		arradj=arrcoraad${arrcorad[menvr]}
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Nombre array de adjuntos $arradj" >> ../$LOG
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Contenido array de adjuntos ${!arradj[menvr]}" >> ../$LOG
		# Enviamos los correos segun los parametros obtenidos
		# Activar para depurar
		echo $msg > rand_$3_$fech_a_${arcarg%.*}/plantilla.html
		#obtenemos fecha del momento
		fech_ran=`date +%s%3N`
		# Obtenemos numero aleatorio
		ran=$((RANDOM % (1 - 29 + 1 ) + 29 ))
		# Activar para depurar
		#echo $3$fech_a$ran
		# Creamos archivo dinamico con extension
		touch rand_$3_$fech_a_${arcarg%.*}/$3$fech_ran$ran.png
		# Creamos la carpeta aleatoria en la carpeta imagenes
		# primero verificamos si existe
		if [ ! -d "../../img/$3_$fech_a" ]
		then
			# si no existe la creamos
			mkdir ../../img/$3_$fech_a
		fi
		# Copiamos la imagen a la carpeta creada
		cp rand_$3_$fech_a_${arcarg%.*}/$3$fech_ran$ran.png ../../img/$3_$fech_a/$3$fech_ran$ran.png
		# Reemplazamos en plantilla original
		sed "s#monitoreocors#http://170.231.80.188:38220/efnmailer/img/$3_$fech_a/$3$fech_ran$ran.png?#g" rand_$3_$fech_a_${arcarg%.*}/plantilla.html > rand_$3_$fech_a_${arcarg%.*}/plantillae.html
		# Activar para depurar
		#sed -i 's#monitoreocors#http://192.168.1.220:35153/efnmailer/img/logo.png?$3$fech_a$ran#g' rand_$3_$fech_a_${arcarg%.*}/plantilla.html
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) la linea insertada es http://170.231.80.188:38220/efnmailer/img/$3$fech_a/$3$fech_ran$ran.png" >> ../$LOG
		#smtp-cli --verbose --host 192.168.1.222 --port 587 --user mlopez@effinet.com.pe --pass te5839525 --from "efnmailer<mlopez@effinet.com.pe>" --to "$nom<$cor>" --subject "$asn" --body-html "$msg" eval ${!arradj[menvr]} | grep "235"
		#smtp-cli --verbose --host 192.168.1.222 --port 587 --user mlopez@effinet.com.pe --pass te5839525 --from "efnmailer<mlopez@effinet.com.pe>" --to "hola<mlopez@effinet.com.pe>" --subject "asd" --body-html "asd" --attach "adjunto/2017-01-26-07-43-50adj_GetMDRCD[1].aspx" | grep "235"
		#echo smtp-cli --verbose --host "'""${prmcon[3]}""'" --port "'""${prmcon[4]}""'" --user "'""${arrcoru[$cenvr]}""'" --pass "'""${arrcorc[$cenvr]}""'" --from "${arrcorl[$cenvr]}<${arrcoru[$cenvr]}>" --to "$nom<$cor>" $cc --subject "$asn" --body-html "<tbody>" eval ${!arradj[menvr]}
		#echo ${!arradj[menvr]}
		#smtp-cli --verbose --host ${prmcon[3]} --port ${prmcon[4]} --user ${arrcoru[$cenvr]} --pass ${arrcorc[$cenvr]} --from "efnmailer - Servicio Al Cliente<${arrcoru[$cenvr]}>" --to "$nom<$cor>" --cc ${prmcon[5]} --subject "$asn" --body-html "$msg" eval ${!arradj[menvr]} | grep "235"
		#cmd=$(smtp-cli --verbose --host "${prmcon[3]}" --port "${prmcon[4]}" --user "${arrcoru[$cenvr]}" --pass "${arrcorc[$cenvr]}" --from "${arrcorl[$cenvr]}<${arrcoru[$cenvr]}>" --to "$nom<$cor>" $cc --subject "$asn" --body-html "$msg" ${!arradj[menvr]} | grep "235")
		#cmd=$(smtp-cli --verbose --host "${prmcon[3]}" --port "${prmcon[4]}" --user "${arrcoru[$cenvr]}" --pass "${arrcorc[$cenvr]}" --from "${arrcorl[$cenvr]}<${arrcoru[$cenvr]}>" --to "$nom<$cor>" $cc --subject "$asn" --body-html "$msg"  | grep "235")
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) smtp-cli --verbose --host ${arrcors[$cenvr]} --port ${arrcorp[$cenvr]} --user ${arrcoru[$cenvr]} --pass ${arrcorc[$cenvr]} --from '${arrcorl[$cenvr]}<${arrcoru[$cenvr]}>' --to '$nom<$cor>' $cc --subject '$asn' --body-html 'rand_$3_$fech_a_${arcarg%.*}/plantilla.html' ${!arradj[menvr]} | grep '235'" >> ../$LOG
		# Activar para depurar
		#echo "`date '+%Y-%m-%d %H:%M:%S'`: 82-$((regbu7=regbu7+1)) smtp-cli --verbose --host ${prmcon[3]} --port ${prmcon[4]} --user ${arrcoru[$cenvr]} --pass ${arrcorc[$cenvr]} --from '${arrcorl[$cenvr]}<${arrcoru[$cenvr]}>' --to '$nom<$cor>' $cc --subject '$asn' --body-html '$msg' ${!arradj[menvr]}" >> $LOG
		cmd="smtp-cli --verbose --host ${arrcors[$cenvr]} --port ${arrcorp[$cenvr]} --user ${arrcoru[$cenvr]} --pass ${arrcorc[$cenvr]} --from '${arrcorl[$cenvr]} <${arrcoru[$cenvr]}>' --to '$nom <$cor>' $cc --subject '$asn' --body-html 'rand_$3_$fech_a_${arcarg%.*}/plantillae.html' ${!arradj[menvr]} | grep '235'"
		#echo $cmd
		# Activar para depurar
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) ....El resultado del comando de envio es: $cmd" >> ../$LOG
		# Almacenamos estado en variable
		cmd_est=`eval $cmd`
		# Activar para depurar
		#echo $cmd_est
		# Realizamos un if que evalue si el envio se realizo de manera correcta
		if [[ $cmd_est = *"successful"* ]]
		then
			# asignamos codigo de envio exitoso
			envest=1
		# de lo contrario
		else
			# asignamos codigo de envio fallido
			envest=0
		fi
		# Obtenemos fecha actual de envio
		fech_e=`date +%s`
		# Insertamos el registro en la tabla reportes del mail masivo
		mysql efnmailer -u $usu -p$cont -se "insert into w_emlmsg (msg_cenv, msg_seq, msg_fec, msg_tipo, msg_rem, msg_dst, msg_cco, msg_asn, msg_tex, msg_reg, msg_est, msg_cmon, aut_cusu) values ($2,$x,$fech_s,$1,'${arrcorl[$cenvr]}-${arrcoru[$cenvr]}','$nom-$cor','${prmcon[5]}','$asn','$msg',$fech_e,$envest,$3$fech_ran$ran,$3)"
		#echo "insert into w_emlmsg (msg_cenv, msg_seq, msg_fec, msg_tipo, msg_rem, msg_dst, msg_cco, msg_asn, msg_tex, msg_est) values ($2,$x,$fech_e,1,'${arrcorl[$cenvr]}-${arrcoru[$cenvr]}','$nom-$cor','${prmcon[5]}','$asn','$msg',$envest)"
		# Eliminamos la linea leida
		sed -i "$nran d" rand_$3_$fech_a_${arcarg%.*}/$parccar
		# Disminuimos los registros en uno
		((nreg=nreg-1))
		# Activar para depurar
		#echo "el primer valor del array es ${resul[x]}"
		#echo "el primer indice del array es ${!resul[x]}"
		# Activar para depurar, sirve para saber cuantas vueltas realizo el bucle
		echo $((asde=asde+1))
		echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) ....Entramos evaluacion de tiempo entre mensajes $nran" >> ../$LOG
		# Validamos si el contador es igual que la cantidad de registros que tiene el pedazo
		if [[ $x -eq $lin ]]
		then
			echo "$x de $lin - `date '+%Y-%m-%d %H:%M:%S'` | destinatario: $cor | remitente: ${arrcoru[$cenvr]} | asunto: $asn | estado: $cmd_est | esperando: $tmp1" >> ../$LOGe
			# Si el numero de registros es igual a la cantidad de lineas del archivo, finalizamos el blucle
			echo "`date '+%Y-%m-%d %H:%M:%S'`: FINALIZA BLUCLE PEDAZO POR LLEGAR A ULTIMO REGISTRO" >> ../$LOG
			break
		# De lo contrario si aun no terminamos la serie,y el segundo tiempo aleatorio es igual a cero y estamos en modo masivo
		elif [[ $((tmp2)) -eq 0 && $1 -eq 2 ]]
		then
			# De ser asi no utilizamos segundo parametro de tiempo
			# Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Modo masivo sin cadencia, se toma como tiempo de espera el primer tiempo" >> ../$LOG
			# Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) El tiempo de espera es $tmp1" >> ../$LOG
			# Registramos en log de envio el mensaje enviado
			echo "$x de $lin - `date '+%Y-%m-%d %H:%M:%S'` | destinatario: $cor | remitente: ${arrcoru[$cenvr]} | asunto: $asn | estado: $cmd_est | esperando: $tmp1" >> ../$LOGe
			# Esperamos la cantidad de tiempo necesaria segun la variable actual
			sleep $tmp1
		# De lo contrario si estamos en modo masivo y se asume que al no evaluar la variable tmp2
		# estamos en modo masivo con cadencia lo cual significa que tendremos que usaremo primer tiempo
		# y segundo tiempo para determinar el tiempo de espera aleatorio
		elif [[ $1 -eq 2 ]]
		then
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Modo masivo con cadencia" >> ../$LOG
			# Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) El primer tiempo es $tmp1" >> ../$LOG
			# ========INICIO CADENCIA FORMULA RONCAL=======
			# Sumamos 1 al segundo tiempo para obtener el rango con cero
			#tmpaum=$((tmp2+1))
			# Activar para depurar
			#echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Segundo tiempo aumentado en uno es $tmpaum" >> $LOG
			# Realizamos calculo matematico para obtener el numero de cadencia,
			# Primero obtenemos el numero random entre cero y el segundo tiempo
			#nran=$(( RANDOM % $tmpaum ))
			# Activar para depurar
			#echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Numero aleatorio obtenido con limite del segundo tiempo es $nran" >> $LOG
			# Luego realizamos la operacion matematica para finalmente obtener el numero ramdom
			#tmp_r=$((tmp1*(1+nran)))
			# Activar para depurar
			#echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Tiempo de espera obtenido al realizar el calculo matematico es $tmp_r" >> $LOG
			# ========FIN CADENCIA FORULA RONCAL=========
			# ========INICIO FORMULA ESTANDAR=========
			tmp_r=$(( RANDOM % (tmp2 - tmp1 + 1 ) + tmp1 ))
			#Activar para depurar
			echo "`date '+%Y-%m-%d %H:%M:%S'`: 88-$((regbu7=regbu7+1)) Tiempo de espera aleatorio obtenido al realizar el calculo es $tmp_r" >> ../$LOG
			# ========FIN FORMULA ESTANDAR=========
			# Registramos en log de envio el mensaje enviado
			echo "$x de $lin - `date '+%Y-%m-%d %H:%M:%S'` | destinatario: $cor | remitente: ${arrcoru[$cenvr]} | asunto: $asn | estado: $cmd_est | esperando: $tmp_r" >> ../$LOGe
			# Esperamos la cantidad de tiempo necesaria segun la variable actual
			sleep $tmp_r
		fi
		# Aumentamos el contador en uno
		((x=x+1))
	done
# Aumentamos contador de numero de archivo en uno
((j=j+1))
# Disminuimos contador de pedazo de archivo en uno
((cntfil=cntfil-1))
echo "`date '+%Y-%m-%d %H:%M:%S'`: FINALIZA BUCLE LINEAS" >> ../$LOG
done
#actualizamos el registro de la tabla proceso para indicar a la plataforma que finalizo el proceso
mysql efnmailer -u $usu -p$cont -se "update w_emlprs set prs_est=2 where aut_cusu like $3 and prs_cenv like $2"
# Modificamos el valor del archivo para indicar que finalizo proceso
echo "2" > ../int/$3_intrp
# movemos la carpeta creada por el envio a masivo
#mv rand_$fech_a_${arcarg%.*} masivo
#echo "El array resultante es"
#echo ${resul[@]}
# Activar para depurar (imprimme indice y contenido de indice)
#for i in "${!resul[@]}"; do
#  printf '${resul[%s]}=%s\n' "$i" "${resul[i]}"
#done
#echo ${!resul[@]}
# Retrodecemos un directorio
cd ..
# Activar para depurar, cuenta la cantidad de items en array
NAME=resul
tmp="${NAME}[@]"
copy=( "${!tmp}" )
echo "`date '+%Y-%m-%d %H:%M:%S'`: 89 La cantidad de elementos en el array resultante es ${#copy[@]}" >> $LOG
echo "`date '+%Y-%m-%d %H:%M:%S'`: ..........FIN ENVIO........." >> $LOGe
echo "`date '+%Y-%m-%d %H:%M:%S'`: =================TERMINO==================" >> $LOG
exit
